#pragma TextEncoding = "Windows-1252"
#pragma rtGlobals=3		// Use modern global access method.
//#pragma version=1.17d// decided to not use pragma but a string constant 

//Partition Functions for High ToF-AMS analysis Toolkit
// Peak Integration by Key Analysis (PIKA)
//Copyright (C) 2005, 2006, 2007,2008, 2009,2010,2011, 2012, 2013, 2014, 2015, 2016, 2017
// Pete DeCarlo, Allison Aiken, Jose Jimenez, Donna Sueper University of Colorado
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
//
///////////////////////////////////////////////////////////////////////////////
// CURRENT STATUS
// see HR read me file for details.


Menu "AMS"

	Submenu "Misc"
	"Partition Average",  /q,PA_GetPAWin()	
	End

End


Function PA_GetPAWin()
	
	string windows=winlist("Partition_Avg_Panel",";","WIN:64")
	if(strlen(windows)>0)
		dowindow/f Partition_Avg_Panel
	else
		PA_CreateGlobals()
		PA_PartitionAvgPanel()
	endif

End


Function PA_CreateGlobals()

	SetDataFolder root:
	NewDataFolder/o Partition_Avg
	
	sq_initializeGlobalNVar("root:Partition_Avg:PA_paritionTime", 120)		// changed default 1.16M
	sq_initializeGlobalNVar("root:Partition_Avg:PA_paritionRun", 5)		// changed default 1.16M
	sq_initializeGlobalNVar("root:Partition_Avg:PA_ck_LinesTime", 1)
	sq_initializeGlobalNVar("root:Partition_Avg:PA_ck_LinesRun", 0)
	sq_initializeGlobalNVar("root:Partition_Avg:PA_NumParitionsPerHdf", 1024) 	// changed default 1.19E

	sq_initializeGlobalSVar("root:Partition_Avg:PA_Min_tdiff_Str", "")
	sq_initializeGlobalSVar("root:Partition_Avg:PA_Max_tdiff_Str", "")
	sq_initializeGlobalSVar("root:Partition_Avg:PA_EstNumNewHDFs", "")

	sq_initializeGlobalNVar("root:Partition_Avg:PA_PartitionMethod", nan)			// 1.16M
	sq_initializeGlobalSVar("root:Partition_Avg:PA_FastExclusionWaveStr", "")			// 1.16M

	// for now assume that if one exists, they all do
	wave/z StartRunTime =  root:Partition_Avg:StartRunTime
	if (!WaveExists(StartRunTime))
		make/d/o/n=0  root:Partition_Avg:StartRunTime, root:Partition_Avg:StopRunTime
		make/i/o/n=0  root:Partition_Avg:StartRun, root:Partition_Avg:StopRun
		make/o/n=0  root:Partition_Avg:NumDAQSecsInPartition, root:Partition_Avg:NumRunsInPartition
		make/o/n=0  root:Partition_Avg:numPntsExclusion, root:Partition_Avg:NumRunsInPartitionLessExclusion
		make/o/n=0  root:Partition_Avg:FastCycleNum		
		make/o/n=0  root:Partition_Avg:FastKeyPart
		make/o/n=0  root:Partition_Avg:PToFCount
		make/o/n=0  root:Partition_Avg:MSCount
		make/i/o/n=0  root:Partition_Avg:NewHDFKey
		make/o/n=0  root:Partition_Avg:numMSRaw
		make/o/n=0  root:Partition_Avg:numMSStick
		make/o/n=0  root:Partition_Avg:numPToFDim1
		make/o/n=0  root:Partition_Avg:numPToFDim2
		note  root:Partition_Avg:StartRun "TYPE:todo"
		note  root:Partition_Avg:StopRun "TYPE:todo"
	endif
	
	wave/z DeltaTime =  root:Partition_Avg:DeltaTime
	wave/z NumDAQSecsInPartition =  root:Partition_Avg:NumDAQSecsInPartition
	if (!WaveExists(DeltaTime))
		make/o/n=(numpnts(StartRunTime))  root:Partition_Avg:DeltaTime
	endif
	if (!WaveExists(NumDAQSecsInPartition))
		make/o/n=(numpnts(StartRunTime))  root:Partition_Avg:NumDAQSecsInPartition
	endif
	
	sq_initializeGlobalNVar("root:Partition_Avg:PA_DoMSSticks", 0)
	sq_initializeGlobalNVar("root:Partition_Avg:PA_DoPToFSticks", 0)
	sq_initializeGlobalNVar("root:Partition_Avg:PA_MaxNumRunsPerNew", -1)			// 1.20H

End


Function PA_PartitionAvgPanel()

	sq_initializeGlobalNVar("root:Partition_Avg:PA_MaxNumRunsPerNew", -1)			// 1.20H
	NewPanel/N=Partition_Avg_Panel /W=(483,53,1143,711) as "Partition_Avg_Panel"
	ModifyPanel fixedSize=1		//1.57L
	ModifyPanel frameInset=8
	ShowTools/A
	SetDrawLayer UserBack
	SetDrawEnv fsize= 18,textrgb= (0,0,65280)
	DrawText 15,23,"Partition, Average and Make New HDFs v"+SQVERSION		//1.19A
	SetDrawEnv fsize= 14
	DrawText 15,258,"0. Press the Get Index button on the main Squirrel panel (if you haven't already done so)."
	SetDrawEnv fsize= 14
	DrawText 15,280,"1. Select Todo wave"
	SetDrawEnv fsize= 14
	DrawText 15,301,"2. Select if PToF sticks are to be included in new files.  Find/Set partition intervals."
	SetDrawEnv fsize= 14
	DrawText 15,493,"3. Check StartRun and StopRun and update other partition waves in table above."
	SetDrawEnv fsize= 14
	DrawText 15,589,"4. Make new averaged daq hdf files from partition waves in table above."
	SetDrawEnv fsize= 14
	DrawText 50,340,"A fixed time grid"
	SetDrawEnv fsize= 14
	DrawText 24,456,"OR a user defined scheme."
	DrawText 50,471,"The user manually sets the values of waves root:Partition_Avg:StartRun and StopRun directly."
	SetDrawEnv fsize= 14
	DrawText 50,374,"OR a fixed number of runs (it will automatically end groupings at v/w mode switches)"
	SetDrawEnv fsize= 14
	DrawText 50,605,"Raw Open and Raw Closed are always included."
	SetDrawEnv fsize= 14
	DrawText 50,412,"OR fast mode cycles (slow mode MS runs will be removed)"
	PopupMenu popup_partitionTodo,pos={167,261},size={120,21},bodyWidth=120,proc=sq_pop_toDoList
	PopupMenu popup_partitionTodo,mode=1,popvalue="all",value= #"root:panel:sq_toDoList"
	Button button_timePart,pos={25,416},size={170,20},proc=PA_butt_SetPartition,title="Create run partition"
	Button button_timePart,fColor=(65280,43520,0)

	CheckBox check1,pos={15,305},size={139,14},title="Also average PToF sticks"
	CheckBox check1,variable= root:Partition_Avg:PA_DoPToFSticks
	SetVariable setvar_time,pos={76,341},size={300,16},title="Partition runs in time, lower limit of duration in seconds"
	SetVariable setvar_time,value= root:Partition_Avg:PA_paritionTime,bodyWidth=50
	SetVariable setvar_numRuns,pos={81,377},size={190,16},bodyWidth=40,title="Partition runs by fixed # of runs"
	SetVariable setvar_numRuns,value= root:Partition_Avg:PA_paritionRun,bodyWidth=50
	TitleBox titleLongestRun,pos={381,310},size={9,9}, frame=0  //1.22A
	TitleBox titleLongestRun,variable= root:Partition_Avg:PA_Max_tdiff_Str
	TitleBox titleShortestRun,pos={381,325},size={9,9}, frame=0  //1.22A
	TitleBox titleShortestRun,variable= root:Partition_Avg:PA_Min_tdiff_Str
	Button button3,pos={25,550},size={360,20},proc=PA_butt_ResetTimeValues,title="Create NumRunsInPart, StartRunTime, etc. in above table"
	Button button3,fColor=(65280,43520,0)
	CheckBox check0,pos={49,610},size={210,14},title="Also average MS sticks (Diff and Closed)"
	CheckBox check0,variable= root:Partition_Avg:PA_DoMSSticks
	SetVariable setvar_numParitionsPerHDF,pos={50,531},size={340,16},proc=PA_SetVar_NumNewRunsInHDF,title="Number of new raw hdf runs (paritions) per hdf file"
	SetVariable setvar_numParitionsPerHDF,value= root:Partition_Avg:PA_NumParitionsPerHdf
	TitleBox title2,pos={400,531},size={132,21}, frame=0 //1.22A
	TitleBox title2,variable= root:Partition_Avg:PA_EstNumNewHDFs
	SetVariable setvar_numMaxRuns,pos={50.00,512.00},size={348.00,18.00},bodyWidth=50,title="Maximum # of runs per 'new' run (-1 means don't limit)"
	SetVariable setvar_numMaxRuns,value= root:Partition_Avg:PA_MaxNumRunsPerNew

	Button button_MakeAvgs,pos={25,631},size={340,20},proc=PA_butt_MakePartitonAvg,title="Make Averages and form new raw hdfs from partition waves"
	Button button_MakeAvgs,fColor=(65280,43520,0)
	Button button_PA_PartitionTable,pos={594,9},size={50,20},proc=sq_butt_popThis,title="Pop"
	CheckBox FixedTime,pos={30,326},size={16,14},proc=PA_CheckParitionOption,title=""
	CheckBox FixedTime,value= 0,mode=1
	CheckBox FixedFast,pos={30,396},size={16,14},proc=PA_CheckParitionOption,title=""
	CheckBox FixedFast,value= 0,mode=1
	CheckBox FixedRun,pos={30,358},size={16,14},proc=PA_CheckParitionOption,title=""
	CheckBox FixedRun,value= 0,mode=1
	SetVariable setvarAdditionalWave,pos={50.00,493.00},size={495.00,18.00},bodyWidth=200,title="Ignore runs where this wave is 1 (leave blank to disable)"
	SetVariable setvarAdditionalWave,value= root:Partition_Avg:PA_FastExclusionWaveStr
	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Partition_Avg:
	Edit/W=(9,38,645,240)/HOST=#
 	PA_populate_PartitionTable()
	RenameWindow #,PartitionTable
	SetActiveSubwindow ##
	
End


Function PA_populate_PartitionTable()

	String fldrSav0= GetDataFolder(1)
	SetDataFolder root:Partition_Avg:
	wave StartRun,StopRun,NumRunsInPartition,StartRunTime,StopRunTime, DeltaTime, NumDAQSecsInPartition  //1.22A
	wave numPntsExclusion,NumRunsInPartitionLessExclusion, FastCycleNum 
	wave PToFCount,MSCount
	wave NewHDFKey,numMSRaw,numMSStick,numPToFDim1,numPToFDim2
	
	AppendToTable StartRun,StopRun,NumRunsInPartition,StartRunTime,StopRunTime, DeltaTime, NumDAQSecsInPartition
	AppendToTable numPntsExclusion,NumRunsInPartitionLessExclusion, FastCycleNum		//1.16M
	AppendToTable PToFCount,MSCount
	AppendToTable NewHDFKey,numMSRaw,numMSStick,numPToFDim1,numPToFDim2
		
	ModifyTable format(Point)=1,width(Point)=52,format(StartRun)=1,digits(StartRun)=1,format(StopRun)=1,digits(StopRun)=1
	ModifyTable width(StartRun)=72,rgb(StartRun)=(0,26112,0),width(StopRun)=72,rgb(StopRun)=(26368,0,52224)
	ModifyTable width(NumRunsInPartition)=48,format(StartRunTime)=8,width(StartRunTime)=120
	ModifyTable rgb(StartRunTime)=(0,26112,0),format(StopRunTime)=8,width(StopRunTime)=120
	ModifyTable rgb(StopRunTime)=(26368,0,52224)
	ModifyTable showFracSeconds(StartRunTime)=1
	ModifyTable showFracSeconds(StopRunTime)=1
	ModifyTable format(NumDAQSecsInPartition)=3
	ModifyTable format(DeltaTime)=7
	SetDataFolder fldrSav0

End


Function PA_butt_PartByTime()

	wave StartRun = root:Partition_Avg:StartRun
	wave StopRun = root:Partition_Avg:StopRun
	wave NumRunsInPartition = root:Partition_Avg:NumRunsInPartition

	wave t_series = root:index:t_series
	wave/i rn_series = root:index:rn_series		// use the all todo wave instead?

	nvar PA_paritionTime = root:Partition_Avg:PA_paritionTime
	svar PA_Min_tdiff_Str = root:Partition_Avg:PA_Min_tdiff_Str
	svar PA_Max_tdiff_Str = root:Partition_Avg:PA_Max_tdiff_Str

	variable/d idex, num, part_begin, part_end, run_index, pt
	
	if (waveexists(t_series) ==0)
		Abort "You must press Get Index before you can partition.  Aborting from PA_butt_PartByTime"
	endif

	ControlInfo popup_partitionTodo
	string todoStr = S_Value
	wave todowave  = $"root:"+todoStr
	variable numruns = (numpnts(t_series))   //1.22A
	make/o/n=(numruns) mymask
	sq_makeMaskFromTodofindRun(mymask,todowave)
	
	num = numpnts(todowave)

	duplicate/o t_series t_diff
	t_diff[0,numruns-2]  = t_series[p+1] - t_series[p]
	t_diff[numruns-1] = t_diff[numruns-2]		// assume the time length of the last run is the same as the previous
	t_diff *= mymask
	
	WaveStats/q/m=1 t_diff
	PA_Min_tdiff_Str =  "Shortest time in secs of any run: "+num2str(V_min)
	PA_Max_tdiff_Str = "Longest time in secs of any run: "+num2str(V_max)
	
	redimension/n=0 StartRun, StopRun
	run_index=0
	idex=0
	
	do
		InsertPoints idex, 1, StartRun, StopRun
		StartRun[idex] = todowave[run_index]
		part_begin = t_series[sq_findRun(rn_series,todowave[run_index])]
		
		do
			run_index+=1
			pt = sq_findRun(rn_series,todowave[run_index])		
		while(t_series[pt] < (part_begin+PA_paritionTime) && run_index<num-1)
		
		StopRun[idex] = todowave[run_index-1]
		
		idex+=1
	while(run_index<num-1)  //1.22A

	Killwaves/z t_diff, mymask

End


Function PA_butt_PartByRunNum()

	wave StartRun = root:Partition_Avg:StartRun
	wave StopRun = root:Partition_Avg:StopRun
	wave NumRunsInPartition = root:Partition_Avg:NumRunsInPartition

	wave/z t_series = root:index:t_series
	wave/z/i rn_series = root:index:rn_series
	
	nvar PA_paritionRun = root:Partition_Avg:PA_paritionRun
	svar PA_Min_tdiff_Str = root:Partition_Avg:PA_Min_tdiff_Str
	svar PA_Max_tdiff_Str = root:Partition_Avg:PA_Max_tdiff_Str

	wave/z ToFTypeVKey = root:diagnostics:ToFTypeVKey
	wave/z ToFTypeWKey = root:diagnostics:ToFTypeWKey
	
	variable/d idex, num, part_begin, part_end, run_index, IsVW=0, currentToFType
	
	if (waveexists(t_series) ==0)
		Abort "You must press Get Index before you can partition.  Aborting from PA_butt_PartByRunNum"
	endif
	
	if (waveexists(ToFTypeVKey) && waveexists(ToFTypeWKey))
		isVW = 1
		currentToFType = ToFTypeVKey[0]
	endif
	
	ControlInfo popup_partitionTodo
	string todoStr = S_Value
	wave todowave = $"root:"+todoStr
	make/o/n=(numpnts(t_series)) mymask
	sq_makeMaskFromTodofindRun(mymask,todowave)
	
	num = numpnts(todowave)
	
	redimension/n=0 StartRun, StopRun
	run_index=0
	idex=0
	
	do
		InsertPoints idex, 1, StartRun, StopRun
		StartRun[idex] = todowave[run_index]
		part_begin = 0
		
		do
			run_index+=1	
			part_begin+=1	
		while(part_begin < PA_paritionRun && run_index<num)
		
		StopRun[idex] = todowave[run_index-1]
		
		idex+=1
	while(run_index<num)

	killwaves/z mymask
End


Function PA_butt_ResetTimeValues(ctrlName) : ButtonControl
	String ctrlName

	wave StartRun = root:Partition_Avg:StartRun
	wave StopRun = root:Partition_Avg:StopRun
	wave StartRunTime = root:Partition_Avg:StartRunTime
	wave StopRunTime = root:Partition_Avg:StopRunTime
	wave NumRunsInPartition = root:Partition_Avg:NumRunsInPartition
	wave FastKeyPart = root:Partition_Avg:FastKeyPart
	
	wave TimeAcquiringMSOpenInRun = root:diagnostics:TimeAcquiringMSOpenInRun
	wave TimeAcquiringMSClosedInRun = root:diagnostics:TimeAcquiringMSClosedInRun
	wave TimeAcquiringPToFInRun = root:diagnostics:TimeAcquiringPToFInRun
	wave durationOfRun = root:diagnostics:durationOfRun
	wave FastKey = root:diagnostics:FastKey

	wave numPntsExclusion = root:Partition_Avg:numPntsExclusion
	wave NumRunsInPartitionLessExclusion = root:Partition_Avg:NumRunsInPartitionLessExclusion
	wave FastCycleNum = root:Partition_Avg:FastCycleNum
	
	nvar PA_PartitionMethod = $"root:Partition_Avg:PA_PartitionMethod"
	svar PA_FastExclusionWaveStr = $"root:Partition_Avg:PA_FastExclusionWaveStr"
	wave/z ExclusionWave = $PA_FastExclusionWaveStr

	wave t_series = root:index:t_series
	wave/i rn_series = root:index:rn_series

	wave/z DeltaTime =  root:Partition_Avg:DeltaTime
	wave/z NumDAQSecsInPartition =  root:Partition_Avg:NumDAQSecsInPartition
	if (!WaveExists(DeltaTime))
		make/o/n=(numpnts(StartRunTime))  root:Partition_Avg:DeltaTime
	endif
	if (!WaveExists(NumDAQSecsInPartition))
		make/o/n=(numpnts(StartRunTime))  root:Partition_Avg:NumDAQSecsInPartition
	endif

	variable idex, num, numOrigRuns = numpnts(rn_series)
	string startStr, stopStr, additionalTodoStr

	SetDataFolder root:		//1.59F
	ControlInfo /w=Partition_Avg_Panel popup_partitionTodo
	svar sq_toDoWvNm=root:panel:sq_toDoWvNm
	if (!stringmatch(S_Value,sq_toDoWvNm) )  //1.22A
		abort "Please reselect your todo wave."
	endif
	wave todo = $"root:"+sq_toDoWvNm
	if (numpnts(todo) == 0)
		abort "Please reselect your todo wave."
	endif
	
	//1.20H
	nvar/z PA_MaxNumRunsPerNew = root:Partition_Avg:PA_MaxNumRunsPerNew
	if (NVar_exists(PA_MaxNumRunsPerNew) && PA_MaxNumRunsPerNew>2)
		PA_MaxNumRunsInPartition(PA_MaxNumRunsPerNew)
	endif
	
	if (WaveExists(ExclusionWave))
		if (numOrigRuns != numpnts(ExclusionWave))
			abort "The number of points in your exclusion wave is not the same as the total number of runs."
		elseif(WaveType(ExclusionWave) <= 2)
		
		endif
	elseif(strlen(PA_FastExclusionWaveStr)>0 && !WaveExists(ExclusionWave))
		abort "There is trouble finding the exclusion wave. Is there a typo? Clear the entry if you do not wish to use an exclusion wave."	
	endif

	num=numpnts(StartRun)
	redimension/n=(num) StartRunTime, StopRunTime, NumRunsInPartition, NumDAQSecsInPartition, DeltaTime, NumDAQSecsInPartition
	redimension/n=(num) numPntsExclusion, NumRunsInPartitionLessExclusion, FastCycleNum
	redimension/n=(num) FastKeyPart

// find the row numbers of where partitions start and stop
	make/i/o/n=(num)  root:Partition_Avg:runStartPt,  root:Partition_Avg:runStopPt
	wave runStartPt = root:Partition_Avg:runStartPt
	wave runStopPt = root:Partition_Avg:runStopPt
	runStartPt = sq_findRun(rn_series,round(StartRun[p]))
	runStopPt = sq_findRun(rn_series,round(StopRun[p]))
		
//  first make sure that the runs in the selected todo 
//	if ( WaveMin(runStartPt)<0 || WaveMin(runStopPt)<0)
//		Wavestats/q/m=1 runStartPt
//		if (V_min<0)
//			abort "At row "+Num2istr(V_minLoc)+ " the StartRun isn't a valid run." 
//		else
//			Wavestats/q/m=1 runStopPt
//			abort "At row "+Num2istr(V_minLoc)+ " the StopRun isn't a valid run." 
//		endif
//	endif

// find the number of runs within each partition (ignoring for the moment any exclusion wave)	
// 	for (idex=0;idex<num;idex+=1)
//		sprintf startStr, "%d", StartRun[idex]
//		sprintf stopStr, "%d", StopRun[idex]
//		sq_create_todo(startStr+"-"+stopStr+" and "+sq_toDoWvNm,"MyTempToDoWave")		// this removes any blacklisted runs
//		wave MyTempToDoWave = root:MyTempToDoWave
//		NumRunsInPartition[idex] =numpnts(MyTempToDoWave)
//	endfor	
//	Killwaves/z MyTempToDoWave

	PA_verifyRuns(StartRun, StopRun, runStartPt, runStopPt, todo)  // does all the checking
	
// not sure that I like this next section much.... am keeping for possible backwards compatibility
// find wave that will help with setting 'duration of run' types of values
	wave t_series = root:index:t_series
	make/free/o/n=(numpnts(t_series)) timeDaq		//1.19C
	if (WaveExists(ExclusionWave))
		timeDaq =(TimeAcquiringMSOpenInRun[p] + TimeAcquiringMSClosedInRun[p] +TimeAcquiringPToFInRun[p])*(!ExclusionWave[p])
	else
		timeDaq =(TimeAcquiringMSOpenInRun[p] + TimeAcquiringMSClosedInRun[p] +TimeAcquiringPToFInRun[p])
	endif
	wave todowave = $"root:"+sq_toDoWvNm
	make/o/n=(numpnts(t_series)) mymask
	sq_makeMaskFromTodofindRun(mymask,todowave)
	duplicate/o t_series t_diff
	t_diff[0,numOrigRuns-2] = t_series[p+1] - t_series[p]
	t_diff[numOrigRuns-1] = t_diff[numOrigRuns-2]		// assume the time length of the last run is the same as the previous
	t_diff[1,numOrigRuns-2] = t_series[p] - t_series[p-1]		//1.15E
	t_diff[0] = t_diff[1]		// assume the time length of the last run is the same as the previous
	t_diff *= mymask

	StartRunTime = t_series[runStartPt[p]]
	StopRunTime = t_series[runStopPt[p]] + t_diff[runStopPt[p]] //-1	
	
	NumDAQSecsInPartition = sum(durationofRun,runStartPt[p], runStopPt[p] )
	deltaTime = StopRunTime - StartRunTime
	
	PA_SetVar_NumNewRunsInHDF("",0,"","")		// update string in panel

	Wave/z ExclusionWave = $PA_FastExclusionWaveStr 
	if (PA_PartitionMethod == 3 )			//1.16M
		if (strlen(PA_FastExclusionWaveStr)> 0)
			 if ( !WaveExists(ExclusionWave))
				abort "Could not find the exclusion wave "+PA_FastExclusionWaveStr
			else
				numDAQSecsInPartition[] = sum(timeDaq, runStartPt[p], runStopPt[p] )	
				FastKeyPart[] = FastKey[ runStartPt[p] ]		// indicates if in fast open or fast closed
				numPntsExclusion[]=sum(ExclusionWave, runStartPt[p], runStopPt[p])
				NumRunsInPartitionLessExclusion[] = NumRunsInPartition[p] - numPntsExclusion[p]
			endif
		endif
		PA_FindCycleNum()
	endif

	PA_DeleteEmptyCycles()  	//1.16M

	PA_NewHDFFileKey()		//1.19C
	nvar PA_NumParitionsPerHdf = root:Partition_Avg:PA_NumParitionsPerHdf
	PA_setVar_NumNewRunsInHDF("",PA_NumParitionsPerHdf,"","")
	
	killwaves/z tempStartFastTodo, timeDaq, mymask,t_diff,FMSStart, todoStrMore, tempTodo
	
End


Function PA_butt_AppendVertLines(ctrlName) : ButtonControl
	String ctrlName

	wave StartRunTime = root:Partition_Avg:StartRunTime
	wave StopRunTime = root:Partition_Avg:StopRunTime
	wave StartRun = root:Partition_Avg:StartRun
	wave StopRun = root:Partition_Avg:StopRun
	
	nvar PA_ck_LinesTime = root:Partition_Avg:PA_ck_LinesTime

	duplicate/o StartRun   root:Partition_Avg:DisplayPA_TimeY
 	wave DisplayPA_TimeY = root:Partition_Avg:DisplayPA_TimeY
 	
	GetAxis left	
	DisplayPA_TimeY = 10^8  // ceil(V_max*2)  // so don't get things too off scale		// some arbitrary value
 	
 	if(PA_ck_LinesTime)
		AppendToGraph DisplayPA_TimeY vs StartRunTime
		AppendToGraph DisplayPA_TimeY vs StopRunTime
	else
		AppendToGraph DisplayPA_TimeY vs StartRun
		AppendToGraph DisplayPA_TimeY vs StopRun
	endif
	
	GetAxis left	
	SetAxis left V_min, V_max
	ModifyGraph lsize(DisplayPA_TimeY)=2, lsize(DisplayPA_TimeY#1)=2
	ModifyGraph mode(DisplayPA_TimeY)=1, mode(DisplayPA_TimeY#1)=1
	ModifyGraph rgb(DisplayPA_TimeY)=(0,26112,0), rgb(DisplayPA_TimeY#1)=(26368,0,52224)

End


Function PA_check_DisplayVertLinesTime(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

 	PA_check_DisplayVertLines(ctrlName, checked)
	
End


Function PA_check_DisplayVertLinesRun(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked

 	PA_check_DisplayVertLines(ctrlName, checked)
 	
End


Function PA_check_DisplayVertLines(ctrlName, checked)
	String ctrlName
	Variable checked

	nvar PA_ck_LinesTime = root:Partition_Avg:PA_ck_LinesTime
	nvar PA_ck_LinesRun = root:Partition_Avg:PA_ck_LinesRun

	if (strsearch(ctrlName, "ime", 0)>=0)
		PA_ck_LinesTime	 = checked
		PA_ck_LinesRun	 = !checked
	else
		PA_ck_LinesTime	 = !checked
		PA_ck_LinesRun	 = checked
	endif
	
End


Function PA_setVar_NumNewRunsInHDF(ctrlName,varNum,varStr,varName) : SetVariableControl
	String ctrlName
	Variable varNum
	String varStr
	String varName

	PA_NewHDFFileKey()		//1.20N
	wave/i NewHDFKey = root:Partition_Avg:NewHDFKey
	svar PA_EstNumNewHDFs =root:Partition_Avg:PA_EstNumNewHDFs
	PA_EstNumNewHDFs = "Number of new raw hdfs:"+num2str(Sum(NewHDFKey))
	
End


Function PA_butt_MakePartitonAvg(ctrlName) : ButtonControl
	String ctrlName

	PathInfo PartitionAvgRawHDFs
	if (v_flag ==0)
		NewPath /m= "Where would you like to put the new partitioned & averaged raw hdfs?" PartitionAvgRawHDFs
	endif
	
	Execute "CreateBrowser"			// klunky, but ModifyBrowser close will throw an error if it doesn't already exist
	Execute "ModifyBrowser close"
	
	PA_butt_ResetTimeValues("")	// step 3 in the panel // 1.16M
	
	PA_GetnonMSInfo()  //   InfoVal, ParVal, ComParVal  // 1.51M

	PA_CreateAttWaves("Partition_Avg")
	
	PA_LoadConCatRunInfo()		// loads the runInfo from all files
	
	SetDataFolder root:

	wave squirrel_index = root:index:squirrel_index
	wave series_Index = root:index:series_Index

	wave StartRun = root:Partition_Avg:StartRun
	wave StopRun = root:Partition_Avg:StopRun
	nvar PA_NumParitionsPerHdf = root:Partition_Avg:PA_NumParitionsPerHdf
	nvar PA_PartitionMethod = root:Partition_Avg:PA_PartitionMethod
	svar PA_FastExclusionWaveStr = root:Partition_Avg:PA_FastExclusionWaveStr
	wave NumRunsInPartitionLessExclusion = root:Partition_Avg:NumRunsInPartitionLessExclusion
	wave/i NewHDFKey = root:Partition_Avg:NewHDFKey			//1.19C

 	wave numMSRaw = root:Partition_Avg:numMSRaw
 	wave numMSStick = root:Partition_Avg:numMSStick
 	wave numPToFDim1 = root:Partition_Avg:numPToFDim1
 	wave numPToFDim2 = root:Partition_Avg:numPToFDim2
 	wave MSCount = root:Partition_Avg:MSCount
 	wave PToFCount = root:Partition_Avg:PToFCount

	variable idex, num, startRunNum, stopRunNum, partitionCounter, numInThisHdf
	variable maxspectra, pos, numStickSpectra, numPToFBin, numNewRuns,numOrigRuns, numNewHdfs
	variable MSSOpenExists, MSSDiffExists, MSSClosedExists, PToFExists
	variable MSClosedpos,MSOpenpos,  ptof_stickpos, MSSOpenpos, MSSClosedpos, MSSDiffpos
  	variable PToFCounter =0, MScounter=0
 	variable numMSInThisHdf, numPToFInThisHdf, jdex, idexHdf
  	string todoStr, firstStr, lastStr

	nvar PA_DoMSSticks = root:Partition_Avg:PA_DoMSSticks
	nvar PA_DoPToFSticks = root:Partition_Avg:PA_DoPToFSticks

 	svar PA_FastExclusionWaveStr = root:Partition_Avg:PA_FastExclusionWaveStr
	nvar PA_PartitionMethod = root:Partition_Avg:PA_PartitionMethod

	ControlInfo/W=Partition_Avg_Panel popup_partitionTodo
	wave todowave = $"root:"+S_value
	todoStr = S_value

 	if (PA_PartitionMethod ==3 && strlen(PA_FastExclusionWaveStr)>0)
		wave ExclusionWave = $PA_FastExclusionWaveStr
		sq_create_todo(todoStr + " and not "+NameOfWave(ExclusionWave),"todoStrMore")	
		wave todoStrMore = root:todoStrMore
		if (numpnts(todoStrMore) == 0)
			abort "Please either reselect the todo wave or examine your exclusion wave"
		endif
		todoStr = "todoStrMore"
		wave ExclusionWave = $PA_FastExclusionWaveStr
	endif
	
	print "//** Began creating new HDFs at "+time()
	
	MSOpenpos=FindDimlabel(squirrel_index,2,"MSOpen")	
	MSClosedpos=FindDimlabel(squirrel_index,2,"MSClosed")	
	MSSOpenpos = FindDimlabel(squirrel_index,2,"MSSOpen")
	MSSDiffpos = FindDimlabel(squirrel_index,2,"MSSDiff")
	MSSClosedpos = FindDimlabel(squirrel_index,2,"MSSClosed")
	ptof_stickpos=FindDimlabel(squirrel_index,2,"ptof_stick")	
	MSSOpenExists = MSSOpenpos >= 0
	MSSDiffExists = MSSDiffpos >=0
	MSSClosedExists = MSSClosedpos >=0
	PToFExists = ptof_stickpos >=0

	numNewRuns=numpnts(StartRun)	
	numOrigRuns=DimSize(squirrel_index, 0)
	
 	PA_AvgPartitonNonSpec(StartRun, StopRun, "Partition_Avg") // creates ParValAvg etc
	PA_MakeRunInfo(StartRun, StopRun, "Partition_Avg")		// change for pedro  Pedro_PA_MakeRunInfo(StartRun, StopRun, "Partition_Avg")	
	
 	wave RunInfoAvg = root:Partition_Avg:RunInfoAvg
	wave InfoValAvg = root:Partition_Avg:InfoValAvg
	wave ParValAvg = root:Partition_Avg:ParValAvg
	 	 	
	nvar numColComParVal =  root:Partition_Avg:numColComParVal 
	if (numColComParVal>0)
		wave ComParValAvg = root:Partition_Avg:ComParValAvg
	endif

	idex=0
 	
	make/free/o/n=(numOrigRuns) todoMask
 	sq_makeMaskFromTodofindRun(todoMask,todowave)
	
	numNewHdfs=sum(NewHDFKey)
	  	
 	for (idexHdf=0;idexHdf<numNewHdfs;idexHdf+=1)	// for each new run
 		
		FindValue/i=1/S=(idex+1) NewHDFKey
		if (V_value>1)
			numInThisHdf = V_value-idex
		else
			numInThisHdf = numNewRuns-idex
		endif

		numMSInThisHdf = waveMax(MSCount, idex, idex+numInThisHdf-1)+1
		numPToFInThisHdf = waveMax(PToFCount,idex,idex+numInThisHdf-1)+1
		PToFCounter =0; MScounter=0; 

		duplicate/o/r=[idex, idex+numInThisHdf-1][]  RunInfoAvg root:Partition_Avg:RunInfo/wave=RunInfo 
		duplicate/o/r=[idex, idex+numInThisHdf-1][]  InfoValAvg root:Partition_Avg:InfoVal/wave=InfoVal 
		duplicate/o/r=[idex, idex+numInThisHdf-1][]  ParValAvg root:Partition_Avg:ParVal/wave=ParVal 
		if (numColComParVal>0)
			duplicate/o/r=[idex, idex+numInThisHdf-1][]  ComParValAvg root:Partition_Avg:ComParVal/wave=ComParVal 
		endif

		// These below will be the matrix to be put into the hdf
		make/o/n=(numMSInThisHdf, numMSRaw[idex]) root:Partition_Avg:MSOpen=0
		make/o/n=(numMSInThisHdf, numMSRaw[idex]) root:Partition_Avg:MSClosed=0
		wave MSOpen =  root:Partition_Avg:MSOpen	// matrix for this hdf
		wave MSClosed =  root:Partition_Avg:MSClosed	// matrix for this hdf
		if (PA_DoMSSticks & numMSInThisHdf>0)
			make/o/n=(numMSInThisHdf, numMSStick[idex]) root:Partition_Avg:MSSOpen=0
			make/o/n=(numMSInThisHdf, numMSStick[idex]) root:Partition_Avg:MSSClosed=0
			make/o/n=(numMSInThisHdf, numMSStick[idex]) root:Partition_Avg:MSSDiff=0
			wave MSSOpen = root:Partition_Avg:MSSOpen
			wave MSSClosed = root:Partition_Avg:MSSClosed
			wave MSSDiff = root:Partition_Avg:MSSDiff
		endif
		if (PA_DoPToFSticks && numPToFInThisHdf>0)
			numPToFBin = WaveMax(numPToFDim1, idex, idex+numInThisHdf-1)
			numStickSpectra = WaveMax(numPToFDim2, idex, idex+numInThisHdf-1)
			make/o/n=(numPToFInThisHdf, numPToFBin,numStickSpectra ) root:Partition_Avg:PToF_Stick=0
			wave PToF_Stick = root:Partition_Avg:PToF_Stick
		endif

		//  get to work on each new run in this new hdf
		for(jdex=idex;jdex<idex+numInThisHdf;jdex+=1)
			startRunNum = StartRun[jdex]
			stopRunNum = StopRun[jdex]
			sprintf firstStr, "%d",  startRunNum
			sprintf lastStr, "%d",  stopRunNum
			sq_create_todo(firstStr+"-"+lastStr+" and "+todoStr,"MyTempToDoWave")		// this removes any blacklisted runs
			wave MyTempToDoWave = root:MyTempToDoWave
			// first make a raw averaged spectra wave so that we know how many points in one raw spectra.
			if (numpnts(MyTempToDoWave)==0)
				abort "Something is wrong with this todo wave "+firstStr+"-"+lastStr+" and "+todoStr
			endif
			sq_makeMaskFromTodofindRun(todoMask,MyTempToDoWave)//		Sq_make
													
			if (numtype(MSCount[jdex]) ==0)	// we have MS data
				// open & closed raw spectra. should give nans when there is no MS for all the runs in this MyTempTodoWave
				PA_AvgRawSpecNon_p(MyTempToDoWave, "Partition_Avg", 0)	// creates AvgOpen, AvgClosed
				
				wave AvgOpen = $"root:Partition_Avg:AvgOpen"	// created in PA_AvgRawSpecNon_p
				wave AvgClosed = $"root:Partition_Avg:AvgClosed"	// created in PA_AvgRawSpecNon_p
								
				if (numpnts(AvgOpen)==0 && numpnts(AvgClosed)!=0)		// fast mode
					redimension/n= (numpnts(MSClosed)) AvgOpen
					MSOpen=nan
				endif
				if (numpnts(AvgClosed)==0 && numpnts(AvgOpen)!=0)		// fast mode
					redimension/n= (numpnts(MSOpen)) AvgClosed
					MSClosed=nan
				endif
				
				MSOpen[MScounter][] = AvgOpen[q]
				MSClosed[MScounter][] = AvgClosed[q]				
				
				if (PA_DoMSSticks)
					if (MSSOpenExists)
						PA_RoughAvg(MyTempToDoWave, "Partition_Avg", 0, "MSSOpen", MSSOpenpos)
						wave AvgMSSOpen = root:Partition_Avg:AvgMSSOpen
						MSSOpen[MScounter][] = AvgMSSOpen[q]
					endif
					if (MSSClosedExists)
						PA_RoughAvg(MyTempToDoWave, "Partition_Avg", 0, "MSSClosed", MSSclosedpos)
						wave AvgMSSClosed = root:Partition_Avg:AvgMSSClosed		
						MSSClosed[MScounter][] = AvgMSSClosed[q]
					endif
					if (MSSDiffExists)
						PA_RoughAvg(MyTempToDoWave, "Partition_Avg", 0, "MSSDiff", MSSDiffpos)
						wave AvgMSSDiff = root:Partition_Avg:AvgMSSDiff	
						MSSDiff[MScounter][] = AvgMSSDiff[q]		//1.19
					endif										
				endif		// do MS sticks
				MScounter+=1
			endif		// this run has MS
			
			if (PA_DoPToFSticks && numtype(PToFCount[jdex]) ==0)	
				PA_RoughAvg(MyTempToDoWave, "Partition_Avg", 0, "ptof_stick", ptof_stickpos, PToFflag=1)
				wave AvgPtof_stick = root:Partition_Avg:AvgPtof_stick  // was created to contain ptof data for every run
				PToF_Stick[PToFCounter][][] = AvgPtof_stick[q][r]		//1.19
				PToFCounter+=1
			endif
				
		endfor 	// this hdf
		
		PA_CreateAvgHdf(idex, MSOpen, MSClosed)		
		idex+=	numInThisHdf
	endfor		// all new runs
	
	killwaves/z MyTempToDoWave, allRunInfo, RUnInfo_att,todoStrMore
	
	PathInfo PartitionAvgRawHDFs
	print "//** Finished creating "+num2str(numNewHdfs)+" new HDFs at "+time()+".  The location of the files is "+S_path
	
	Execute "CreateBrowser"
	SetDataFolder root:
	
End


Function PA_CreateAvgHdf(index, MSOpen, MSClosed)
variable index
wave MSOpen, MSClosed

	string AvgHdfFileName, tempstr
	string ErrorMsg ="", SqDataSetStr, SqDataSetList, timestr, firstRunStr
	variable fileID,SqDataSetVar, idex, num
	
	nvar PA_DoMSSticks = root:Partition_Avg:PA_DoMSSticks
	nvar PA_DoPToFSticks = root:Partition_Avg:PA_DoPToFSticks

	wave StartRunTime = root:Partition_Avg:StartRunTime
	wave StartRun = root:Partition_Avg:StartRun
	 
	sq_initializeGlobalSVar("root:panel:HdfFileExtension", "hdf")  //1.52M
	svar HdfFileExtension= root:panel:HdfFileExtension		//1.52M

	wave squirrel_index = root:index:squirrel_index
	variable MSSOpenExists, MSSDiffExists, MSSClosedExists, PToFExists
	variable tempVar

	nvar numColComParVal =  root:Partition_Avg:numColComParVal 
	SqDataSetList = "RunInfo;ParVal;InfoVal" +selectString(numColComParVal>0, "", ";ComParVal")
	
	MSSOpenExists = FindDimlabel(squirrel_index,2,"MSSOpen")>=0
	MSSDiffExists = FindDimlabel(squirrel_index,2,"MSSDiff")>=0
	MSSClosedExists = FindDimlabel(squirrel_index,2,"MSSClosed")>=0
	PToFExists = FindDimlabel(squirrel_index,2,"ptof_stick")>=0

	 timestr = sq_Time2yyyymmddhhmmss(StartRunTime[index])
	sprintf firstRunStr, "%d", StartRun[index]		//1.51M
	 tempstr="0000000"+firstRunStr		// prepend zeros
	 tempstr=tempstr[strlen(tempStr)-7, strlen(tempStr)-1]		
	 
	AvgHdfFileName=timestr[2,7]+"_"+tempstr+"_m."+HdfFileExtension
	// Create a new HDF5 file, overwriting if same-named file exists.
	HDF5CreateFile/P=PartitionAvgRawHDFs /O /Z fileID as AvgHdfFileName
	if (V_flag != 0)
		print "HDF5CreateFile failed for "+AvgHdfFileName
		return -1
	endif
		
	make/o/t/n=1 myTempText
	for (SqDataSetVar=0;SqDataSetVar<ItemsInList(SqDataSetList);SqDataSetVar+=1)
		SqDataSetStr = StringFromList(SqDataSetVar, SqDataSetList)
		
		// Create a local reference to the wave
		Wave w = $"root:Partition_Avg:"+SqDataSetStr
		Wave/t w_att = $"root:Partition_Avg:"+SqDataSetStr+"_att"
		
		HDF5SaveData/IGOR=0 /O /Z w, fileID	// Save wave as dataset.
		if (V_flag != 0)
			ErrorMsg+= "HDF5SaveData failed for "+SqDataSetStr
		endif
		num=numpnts(w_att)
			
		for(idex=0;idex<num;idex+=1)
			myTempText=w_att[idex]
			HDF5SaveData/IGOR=0/A=(SqDataSetStr+"_"+num2str(idex)) /Z myTempText, fileID, SqDataSetStr	// Save wave as dataset.
			if (V_flag != 0)
				ErrorMsg+= "HDF5SaveData failed for "+SqDataSetStr+"_att "+ myTempText[0]		//1.57J
				break
			endif
		endfor
		
	endfor
	
	HDF5SaveData/IGOR=0 /O /Z MSOpen, fileID, "MSOpen"	// Save wave as dataset.
	HDF5SaveData/IGOR=0 /O /Z MSClosed, fileID, "MSClosed"	// Save wave as dataset.

	if (PA_DoMSSticks)
		if(MSSOpenExists)
			wave MSSOpen =  root:Partition_Avg:MSSOpen
			HDF5SaveData/IGOR=0 /O /Z MSSOpen, fileID, "MSSOpen"	// Save wave as dataset.
		endif
		if(MSSClosedExists)
			wave MSSClosed =  root:Partition_Avg:MSSClosed
			HDF5SaveData/IGOR=0 /O /Z MSSClosed, fileID, "MSSClosed"	// Save wave as dataset.
		endif
		if(MSSDiffExists)
			wave MSSDiff =  root:Partition_Avg:MSSDiff
			HDF5SaveData/IGOR=0 /O /Z MSSDiff, fileID, "MSSDiff"	// Save wave as dataset.
		endif
	endif

	if (PA_DoPToFSticks && PToFExists)
		wave PToF_Stick =  root:Partition_Avg:PToF_Stick
		tempstr = Note(PToF_Stick)
		tempVar =NumberByKey("numrows",tempstr)
		if (tempVar< dimsize(PToF_Stick,0))
			redimension/n=(tempVar,-1,-1) PToF_Stick
		endif
		HDF5SaveData/IGOR=0 /O /Z PToF_Stick, fileID, "PToF_Stick"	// Save wave as dataset.
	endif

	killwaves/z myTempText
	
	// Close the HDF5 file.
	HDF5CloseFile fileID
	
	if ( strlen(errorMsg)>0  )
		DoAlert 1, errorMsg
	else
		print "File "+AvgHdfFileName+" created successfully."
	endif
	
End


Function PA_MakeRunInfo(StartRun, StopRun, DataFolderName)
wave StartRun, StopRun
string DataFolderName

	//    * Column 1-1 contains the Run Number
	//    * Column 2-1 contains the Year
	//    * Column 3-1 contains the Julian Day
	//    * Column 4-1 contains the seconds after midnight
	//    * Column 5-1 contains the ToF type (0=c, 1=v, 2=w; For older data, where ToF type was not included in ParVal, HDFwriter will output NaN)
	//    * Column 6-1 contains a value representing the count of the MS runs
	//    * Column 7-1 contains a value representing the active modes of acquisition. MS=1; PToF=2; BFSP=3.4=fastopen 5 = FastClosed, Numbers are combined to indicate General Alternation mode. For instance, MS/PToF=12 and PToF/BFSP=23. (used for Squirrel Indexing) 
	//    * Column 8-1 contains a value representing the count of the PToF runs
	
	wave AllRunInfo = root:allRunInfo
	wave rn_series = root:index:rn_series
	wave t_series = root:index:t_series
	wave NewHDFKey = root:Partition_Avg:NewHDFKey	
	
	nvar PA_NumParitionsPerHdf =  $"root:"+DataFolderName+":PA_NumParitionsPerHdf"
	
	variable idex, num, startRunVal, ptStartRun, timeValue, year, julianDay, secsAfterMidnight, goodRuncounter, col7Val
	variable msCounter=0, ptofCounter=0, ptofflag, msflag
	string timeStr	

	nvar numColRunInfo =  root:Partition_Avg:numColRunInfo 		//1.51M

	num=numpnts(StartRun)
	make/o/n=(num, numColRunInfo) $"root:"+DataFolderName+":RunInfoAvg"
	wave RunInfoAvg = $"root:"+DataFolderName+":RunInfoAvg"
	make/o/n=(numColRunInfo) $"root:"+DataFolderName+":RunInfoOne"
	wave RunInfoOne = $"root:"+DataFolderName+":RunInfoOne"

	num=numpnts(StartRun)
	goodRuncounter=0
	
	wave allRunInfo = root:allRunInfo
	string startStr, stopStr
	
	msCounter=00
	ptofCounter=0
	for(idex=0;idex<num;idex+=1)
		sprintf startStr, "%d",  StartRun[idex]
		sprintf stopStr, "%d",  StopRun[idex]
		sq_create_todo(startStr+"-"+StopStr+" and all","MyTempToDoWave")		// this removes any blacklisted runs
		wave/i MyTempToDoWave
				
		if (NewHDFKey[idex]==1 )  //  || mod(idex+1,PA_NumParitionsPerHdf)==0)
			goodRuncounter=0
			ptofCounter=0			//1.19C
			msCounter=0
		endif

		if (numpnts(MyTempToDoWave)>0)
			goodRuncounter+=1
			startRunVal = round(StartRun[idex])
			ptStartRun = sq_findRun(rn_series, round(startRunVal))
			
			msflag=0
			ptofflag=0
			if(numtype(AllRunInfo[ptStartRun][5])==0 )
				msCounter+=1
				msFlag=1		
			endif
			if( numtype(AllRunInfo[ptStartRun][7])==0 )
				ptofCounter+=1		
				ptofFlag=1		
			endif
			
			timeValue = t_series[ptStartRun]
			timeStr = Secs2Date(timeValue, -1 )  // prints   15/03/1993 (2)
			
			year = str2num(timeStr[6,9])
			julianDay = floor( (timeValue-date2secs(year,1,1))/86400) 
			secsAfterMidnight = (timeValue-date2secs(year,1,1)) - (julianDay*86400)
			
			RunInfoOne[0] = startRunVal
			RunInfoOne[1] = year
			RunInfoOne[2] = julianDay
			RunInfoOne[3] = secsAfterMidnight
			RunInfoOne[4] = 1
			RunInfoOne[5] = msFlag? msCounter :  nan	// we need to fill these in of MS counter
			RunInfoOne[6] = AllRunInfo[ptStartRun][6]	// active run mode  MS=1; PToF=2; BFSP=3, 4=fastopen 5 = FastClosed  assume that we don't combine different modes
			RunInfoOne[7] = ptofFlag? ptofCounter :  nan// we need to fill these in for PToF counter
			// for now we leave the other columns blank
			RunInfoAvg[idex][]=RunInfoOne[q]
		else		// this shouldn't happen....
			abort "Not sure why this is happening but we have no runs to average over"		//1.16M
			RunInfoAvg[idex][]=nan
		endif
		
	endfor

	Killwaves/z RunInfoOne, MyTempToDoWave

End

    
Function PA_AvgPartitonNonSpec(StartRun, StopRun, DataFolderName)
wave StartRun, StopRun
string DataFolderName		//Partition_Avg

	nvar numColParVal =  root:Partition_Avg:numColParVal 
	nvar numColInfoVal =  root:Partition_Avg:numColInfoVal 
	nvar numColComParVal =  root:Partition_Avg:numColComParVal 

	variable idex, num, nOpen, nClosed, RunNumStart, RunNumStop

	wave/t InfoValText= root:diagnostics:InfoValText		//1.15C
	wave/t/z ParValText = root:diagnostics:ParValText
//	wave/t InfoText= root:index:InfoText
//	wave/t/z ParStr = root:index:ParStr
	if (!waveExists(ParValText) )
		wave/t ParValText = root:index:ParStr_		// bug in squirrel versions <.1.43
	endif
	if (numColComParVal>0)
		wave/t CommonParText= root:diagnostics:CommonParText  // root:index:CommonParStr
	endif
	
	NewDataFolder/o $"root:"+DataFolderName
	num = numpnts(StartRun)
	
	make/o/n=(numColParVal) $"root:"+DataFolderName+":ParValOneRun"
	make/o/n=(numColInfoVal) $"root:"+DataFolderName+":InfoValOneRun"
	wave ParValOneRun = $"root:"+DataFolderName+":ParValOneRun"
	wave InfoValOneRun = $"root:"+DataFolderName+":InfoValOneRun"
	if (numColComParVal>0)
		make/o/n=(numColComParVal) $"root:"+DataFolderName+":ComParValOneRun"		//1.19A
		wave ComParValOneRun = $"root:"+DataFolderName+":ComParValOneRun"
	endif
	
	make/o/n=(num, numColParVal) $"root:"+DataFolderName+":ParValAvg"
	make/o/n=(num, numColInfoVal) $"root:"+DataFolderName+":InfoValAvg"
	wave ParValAvg = $"root:"+DataFolderName+":ParValAvg"
	wave InfoValAvg = $"root:"+DataFolderName+":InfoValAvg"
	if (numColComParVal>0)
		make/o/n=(num,numColComParVal) $"root:"+DataFolderName+":ComParValAvg"
		wave ComParValAvg = $"root:"+DataFolderName+":ComParValAvg"
	endif

	// for each partition
	for (idex=0;idex<num;idex+=1)
		RunNumStart = StartRun[idex]
		RunNumStop=StopRun[idex]
		PA_InsertAvgsIntoWaves(RunNumStart, RunNumStop,ParValOneRun, InfoValOneRun, Opt_ComParValOneRun = ComParValOneRun)
		ParValAvg[idex][] = ParValOneRun[q]
		InfoValAvg[idex][] = InfoValOneRun[q]
		if (numColComParVal>0)
			ComParValAvg[idex][] = ComParValOneRun[q]
		endif
	endfor

//	killwaves ParValOneRun, InfoValOneRun

End


//  handles blacklist values ok (it does not use them)
// this is good for diagnostic-type waves, not spec -type waves.
Function PA_FindAvgOneWave(ToDoWave, wave2avg, [SumNotAvg])
wave ToDoWave, wave2avg
variable SumNotAvg

	wave rn_series = root:index:rn_series	
	
	variable idex, num, pt, thisSum
	
	num=numpnts(ToDoWave)
	thisSum=0
	
	for(idex=0;idex<num;idex+=1)
		thisSum+=wave2avg[sq_findRun(rn_series,ToDoWave[idex])]
	endfor
	
	variable DoAvg = ParamIsDefault(SumNotAvg) || SumNotAvg==0
	if (numpnts(ToDoWave)>0)
		if (!DoAvg)
			return thisSum
		else
			return thisSum/num
		endif
	else
		return nan
	endif
	
End


Function PA_InsertAvgsIntoWaves(RunNumStart, RunNumStop,ParValOneRun, InfoValOneRun, [Opt_ComParValOneRun])
variable RunNumStart, RunNumStop
wave ParValOneRun, InfoValOneRun, Opt_ComParValOneRun

	wave/t diag_list = root:diagnostics:diag_list
	wave diag_loc = root:diagnostics:diag_loc
	nvar chopper_duty=root:diagnostics:chopper_duty		//^ assumed to be constant for one experiment, instrument
	nvar cor3_chamber=root:panel:cor3_chamber

	variable idex, num, thisAvg
	string str
	
	ParValOneRun = -99
	InfoValOneRun = -99
	if (!ParamIsDefault(Opt_ComParValOneRun) )
		Opt_ComParValOneRun = -99	
	endif	
	
	ControlInfo popup_partitionTodo
	wave todowave = $"root:"+S_value
	string startStr, stopStr
	sprintf startStr, "%d", RunNumStart
	sprintf stopStr, "%d", RunNumStop
	
	sq_create_todo(startStr+"-"+stopStr+" and "+S_value,"MyTempToDoWave")		// this removes any blacklisted runs
	wave/i MyTempToDoWave
	
	if (numpnts(MyTempToDoWave)==0)
		return 0
	endif
	
	num=numpnts(diag_list)

	string Sumlist=""		// for these parameters we want the sum not the average
	Sumlist+="TotalTimeElapsedInRun;"		
	Sumlist+="SecsInPToF;SecsInMS;"
	Sumlist+="numBuffersSavedMSOpen;numBuffersSavedMSClosed;"	
	Sumlist+="SampledTime;FastModeAvgTimeSec;"
	Sumlist+="TimeAcquiringMSOpenInRun;TimeAcquiringMSClosedInRun;TimeAcquiringPToFInRun;DurationOfRun;"
	Sumlist+="FastModeAvgTimeSec;"	// 	fastMSRunWithinCycle, fastMSTimeWithinCycle
	variable SumONly
	for (idex=0;idex<num;idex+=1)
		str = diag_list[idex]
		wave/z wav = $"root:diagnostics:"+Str
		// for pre-ron brown these diagnositic waves don't exist:ionizationType, tps_Drift:tps_setFileMajor:tps_setFileMinor
		if (WaveExists(wav)==1)
	
			SumONly=(WhichListItem(str,Sumlist)>=0)
			thisAvg = PA_FindAvgOneWave(MyTempToDoWave, wav, SumNotAvg= (WhichListItem(str,Sumlist)>=0))
//			if (SumONly)
//				print str, thisAvg
//			endif
			
			switch (diag_loc[idex][0])
			case 0:			// InfoVal corresponds to 0 in the first column of diag_loc
				InfoValOneRun[diag_loc[idex][1]]=thisAvg
				break
			case 1:
				ParValOneRun[diag_loc[idex][1]]=thisAvg
				break
			case 3:
				Opt_ComParValOneRun[diag_loc[idex][1]]=thisAvg
				break
			case 2: //^ Special cases
          			strswitch (diag_list[idex])
           				case "ToFPulserInHz":
           					ParValOneRun[4]=1/(thisAvg*1e-6)
           					//dest[p1]=1/(source1[idex][4]*1e-6) //& will need updating if 2GHz data is used;  Time of Flight pulser Period in microseconds (us)
           					break
           			endswitch
			endswitch
		elseif (FindListItem(str,"ionizationType;tps_Drift;tps_setFileMajor;tps_setFileMinor")<0)		// for pre-ron brown these dianositic waves don't exist:ionizationType, tps_Drift:tps_setFileMajor:tps_setFileMinor
			print "This one doesn't exist: "+str
			print FindListItem(str,"ionizationType;tps_Drift;tps_setFileMajor;tps_setFileMinor")
		endif
	endfor
	
	if (!ParamIsDefault(Opt_ComParValOneRun) )
//		cor3_chamber=source2[0][8]		//^ is not a wave, is constant  CommonPar9
//		chopper_duty=source2[0][7]		//^ is not a wave, is constant CommonPar8
		Opt_ComParValOneRun[8] = cor3_chamber
		Opt_ComParValOneRun[7] = chopper_duty
	else
		ParValOneRun[15] =cor3_chamber		//^ is not a wave, is constant  ParVal15
		ParValOneRun[14] =chopper_duty		 //^ is not a wave, is constant  ParVal4
	endif

	killwaves/z MyTempToDoWave

End


Function PA_AvgRawSpecNon_p(ToDoWave, DataFolderName, saveIndividualRaw)
wave ToDoWave
variable saveIndividualRaw
string DataFolderName

	variable idex, num, RunNum, pos, openLay, closedLay
	string paramStr,  firstRunStr	
	wave squirrel_index = root:index:squirrel_index
	wave run_index = root:index:run_index
	
	NewDataFolder/o $"root:"+DataFolderName
	num = numpnts(ToDoWave)
	
	paramStr = "raw_flag:1;cache_op:0;filter_op:1;corr_op:0;product_type:2;ug_op:0;"
	
	pos = sq_FindRun(run_index, ToDoWave[0])
	openLay = finddimLabel(squirrel_index, 2, "MSOpen")
	closedLay = finddimLabel(squirrel_index, 2, "MSClosed")
	
	if(squirrel_index[pos][0][openLay]==0)
		make/o/n=0 	root:MSO_temp
	else
		squirrel_fetch(ToDoWave, sq_MS_concentration, paramStr+"destlist:MSO_temp", "MSOpen")
	endif
	if(squirrel_index[pos][0][closedLay]==0)
		make/o/n=0 	root:MSC_temp
	else
		squirrel_fetch(ToDoWave, sq_MS_concentration, paramStr+"destlist:MSC_temp", "MSClosed")
	endif

	wave MSO_temp = root:MSO_temp
	wave MSC_temp = root:MSC_temp
	duplicate/o MSO_temp $"root:"+DataFolderName+":AvgOpen"
	duplicate/o MSC_temp $"root:"+DataFolderName+":AvgClosed"
	wave AvgOpen = $"root:"+DataFolderName+":AvgOpen"
	wave AvgClosed = $"root:"+DataFolderName+":AvgClosed"

	sprintf firstRunStr, "%d", ToDoWave[0]
	Note/K AvgOpen, "FirstRunInAvg:"+firstRunStr+ ";NumSpectraInAvg:"
	Note/K AvgClosed, "FirstRunInAvg:"+firstRunStr+ ";NumSpectraInAvg:"

	Killwaves/z MSO_temp, MSC_temp
	
End


// can be used to average sticks, or anything that doesn't need fancy weighting
Function PA_RoughAvg(ToDoWave, DataFolderName, saveIndividual, dataSet, dataSetpos, [PToFflag])
wave ToDoWave
variable saveIndividual, dataSetpos, PToFflag
string DataFolderName
string dataSet

	wave run_index = root:index:run_index
	wave squirrel_index = root:index:squirrel_index
	variable idex, num, n2Avg, RunNum, pos
	string paramStr, runNUmStr
	
	NewDataFolder/o $"root:"+DataFolderName
	num = numpnts(ToDoWave)
	n2Avg=0
	
	PToFflag = paramIsDefault(PToFflag) ?  0 : PToFflag

	for (idex = 0; idex< num; idex+=1)
		RunNum = ToDoWave[idex]
		pos = sq_findRun(run_index,RunNum)
		sprintf RunNumStr, "%d", RunNum
//		print RunNumStr
		if (squirrel_index[pos][0][dataSetPos] >0)			//1.52A
			sq_GetThisRawMS(RunNum, DataFolderName, "temp_"+RunNumStr, dataSet)
			wave/z myTemp = $"root:"+DataFolderName+":temp_"+RunNumStr
			if (!WaveExists(myTemp))
				abort "Could not find wave for "+dataset+" and run "+RunNumStr		//1.11D
			endif
			if (idex == 0)
				duplicate/o myTemp $"root:"+DataFolderName+":AvgTemp"
				wave AvgTemp = $"root:"+DataFolderName+":AvgTemp"
			else
				AvgTemp += myTemp
			endif
			
			n2Avg+=1
			
			if (!saveIndividual)
				killwaves/z myTemp
			endif
		endif
	endfor

	if (n2Avg>0) //1.52A
		AvgTemp/=n2Avg
	else
		make/o/n=0  $"root:"+DataFolderName+":AvgTemp"/wave=AvgTemp
	endif
	
	string str
	sprintf str, "%d", todowave[0]
	Note/K AvgTemp, "FirstRunInAvg:"+str
	
//	if (stringmatch(dataset, "PToF_stick") )
//		print ToDoWave[0], n2Avg
//	endif
	duplicate/o AvgTemp $"root:"+DataFolderName+":Avg"+dataSet

End


Function PA_CreateAttWaves(DataFolderStr)
string DataFolderStr

	wave/z/t InfoText = root:diagnostics:InfoText
	wave/z/t ParStr = root:diagnostics:ParStr
	wave/t file_index = root:index:file_index

	if (!WaveExists(ParStr))
		make/t/n=0 root:diagnostics:ParStr
		sq_LoadAttributesFromHDF(file_index[numpnts(file_index)-1], "ParVal",  root:diagnostics:ParStr)
		wave/t ParStr = root:diagnostics:ParStr
	endif
	if (!WaveExists(InfoText))
		make/t/n=0 root:diagnostics:InfoText
		sq_LoadAttributesFromHDF(file_index[numpnts(file_index)-1], "InfoVal",  root:diagnostics:InfoText)
		wave/t InfoText = root:diagnostics:InfoText
	endif

	nvar numColRunInfo =  root:Partition_Avg:numColRunInfo
	nvar numColParVal = root:Partition_Avg:numColParVal 
	nvar numColInfoVal =  root:Partition_Avg:numColInfoVal 
	nvar numColComParVal =  root:Partition_Avg:numColComParVal 

	make/t/o/n=(numColRunInfo) $"root:"+DataFolderStr+":RunInfo_att"
	make/t/o/n=(numColParVal) $"root:"+DataFolderStr+":ParVal_att"
	make/t/o/n=(numColInfoVal) $"root:"+DataFolderStr+":InfoVal_att"
	wave/t RunInfo_att = $"root:"+DataFolderStr+":RunInfo_att"
	wave/t ParVal_att = $"root:"+DataFolderStr+":ParVal_att"
	wave/t InfoVal_att = $"root:"+DataFolderStr+":InfoVal_att"

	if (numColComParVal>0)
		make/t/o/n=(numColComParVal) $"root:"+DataFolderStr+":ComParVal_att"
		wave/t ComParVal_att = $"root:"+DataFolderStr+":ComParVal_att"
	endif
	
	RunInfo_att[000] = "Run Number"
	RunInfo_att[001] = "Year"
	RunInfo_att[002] = "Day of Year"
	RunInfo_att[003] = "Seconds After Midnight"
	RunInfo_att[004] = "ToF type"
	RunInfo_att[005] = "MS ToF type counter"
	RunInfo_att[006] = "Active Modes"
//	RunInfo_att[007] = "PToF ToF type counter"
//	RunInfo_att[008] = "CH2 Mode"
//	RunInfo_att[009] = "CH2 MS ToF type counter"
//	RunInfo_att[010] = "CH2 PToF ToF type counter"
// I decided not to bother with the rest

	InfoVal_att = InfoText
	ParVal_att = ParStr

	if (numColComParVal>0)
		wave/t/z CommonParText = root:diagnostics:CommonParText
//		wave/t CommonParText = root:diagnostics:CommonParText	//  1.15HD
//		wave/t CommonParStr = root:diagnostics:CommonParStr		// modified 1.11B
		if (!WaveExists(CommonParText))
			wave/t/z CommonParStr = root:diagnostics:CommonParStr		// modified 1.11B
			if (!WaveExists(CommonParText))		// 1.15HE
				wave/t ComParValText = root:diagnostics:ComParValText		// modified 1.16M
				make/t/o/n=(numpnts(ComParValText) ) root:diagnostics:CommonParText/wave=CommonParText
				CommonParText = ComParValText			
			else
				rename root:diagnostics:CommonParStr, CommonParText
				wave/t/z CommonParText = root:diagnostics:CommonParText
			endif
		endif
		if (!WaveExists(CommonParText))
			make/t/n=0 root:diagnostics:CommonParText
			sq_LoadAttributesFromHDF(file_index[numpnts(file_index)-1], "InfoVal",  root:diagnostics:CommonParText)
			wave/t CommonParText = root:diagnostics:CommonParText		// modified 1.11B
		endif
		ComParVal_att = CommonParText
	endif
End


// *************************************************
// Returns a string with a 4 char year, 2 char month, etc. from timeVar
Function/S sq_Time2yyyymmddhhmmss(timeVar)
	Variable timeVar

	string returnStr
	string dateStr, timeStr, yyyy,mm,dd,hh,mimi,ss
	variable slashPos1, slashPos2
	
	dateStr=Secs2Date(timeVar,-1) 		//	dateStr =  "18/04/2004" 

	if (strsearch(dateStr, "(", 0)>0 )		// normal
		slashPos1=strsearch(dateStr, "/", 0)
		if(slashPos1==1)
			dd = "0"+dateStr[0]
		else
			dd =dateStr[0,1]
		endif
		
		slashPos2=strsearch(dateStr, "/", slashPos1+1)
		
		if(  (slashPos2 - slashPos1)==2)
			mm =  "0"+dateStr[slashPos2-1]
		else
			mm =dateStr[slashPos1+1,slashPos2-1]
		endif
		yyyy=dateStr[strlen(dateStr)-8, strlen(dateStr)-5]	//  count from the end and ignore the last 4 characeters, space, (, x, )
	
	else	 	// some windows machines aren't cooperative
	
		slashPos1=strsearch(dateStr, "/", 0)
		if(slashPos1==1)
			mm = "0"+dateStr[0]
		else
			mm =dateStr[0,1]
		endif
		
		slashPos2=strsearch(dateStr, "/", slashPos1+1)
		
		if(  (slashPos2 - slashPos1)==2)
			dd =  "0"+dateStr[slashPos2-1]
		else
			dd =dateStr[slashPos1+1,slashPos2-1]
		endif
			
		yyyy=dateStr[slashPos2+1, strlen(dateStr) -1]
		 if (cmpstr(yyyy[0], "0")==0)		// won't work in 2010+
		 	yyyy = "20"+yyyy
		 else
		 	yyyy = "19"+yyyy
		 endif

	endif
		
	timeStr=Secs2Time(timeVar,3)
	hh=timeStr[0, 1]
	mimi=timeStr[3,4]
	ss=timeStr[6,7]
		
	returnStr = yyyy+mm+dd+hh+mimi+ss
		
	return returnStr

End


//1.51M
Function PA_GetnonMSInfo()

	wave/t file_index = root:index:file_index
	variable idex, num, fileID
	
	variable/g root:Partition_Avg:numColRunInfo=0 
	nvar numColRunInfo =  root:Partition_Avg:numColRunInfo 
	variable/g root:Partition_Avg:numColParVal=0 
	nvar numColParVal =  root:Partition_Avg:numColParVal 
	variable/g root:Partition_Avg:numColInfoVal=0
	nvar numColInfoVal =  root:Partition_Avg:numColInfoVal 
	variable/g root:Partition_Avg:numColComParVal=0 
	nvar numColComParVal =  root:Partition_Avg:numColComParVal 
	
	STRUCT HDF5DataInfo di	// Defined in HDF5 Browser.ipf.
	InitHDF5DataInfo(di)

	HDF5OpenFile/z/r/p=HdfDirPath fileID as file_index[0]		// assume others are like the first
	if (V_Flag)
		Abort "There is something wrong with the file "+	file_index[0]+" Try to open it in the HDF5 browser or delete??"
	endif
//	HDF5ListAttributes fileID, "RunInfo"
	HDF5DatasetInfo(fileID , "RunInfo" , 0 , di ) 
	numColRunInfo = di.dims[1] //ItemsInList(S_HDF5ListAttributes) 

//	HDF5ListAttributes fileID, "ParVal"
	HDF5DatasetInfo(fileID , "ParVal" , 0 , di ) 
	numColParVal =  di.dims[1] //ItemsInList(S_HDF5ListAttributes) 

//	HDF5ListAttributes fileID, "InfoVal"
	HDF5DatasetInfo(fileID , "InfoVal" , 0 , di ) 
	numColInfoVal =  di.dims[1]  // ItemsInList(S_HDF5ListAttributes) 

	HDF5ListAttributes/z fileID, "ComParVal"
	if (V_Flag==0)		// operation did not succeed
		HDF5DatasetInfo(fileID , "ComParVal" , 0 , di ) 
		numColComParVal = di.maxdims[1] //ItemsInList(S_HDF5ListAttributes) 		// 1.19A
	endif

	HDF5CloseFile fileID

End


Function PA_CheckParitionOption(ctrlName,checked) : CheckBoxControl
	String ctrlName
	Variable checked
	
	nvar PA_PartitionMethod = $"root:Partition_Avg:PA_PartitionMethod"

	CheckBox FixedTime value= stringmatch(ctrlName, "FixedTime")
	CheckBox FixedRun value= stringmatch(ctrlName, "FixedRun")
	CheckBox FixedFast value= stringmatch(ctrlName, "FixedFast")	
	CheckBox UserDefined value= stringmatch(ctrlName, "UserDefined")	
	
	PA_PartitionMethod = stringmatch(ctrlName, "FixedTime") 
	PA_PartitionMethod = stringmatch(ctrlName, "FixedRun") ? 2 : PA_PartitionMethod
	PA_PartitionMethod = stringmatch(ctrlName, "FixedFast") ? 3 : PA_PartitionMethod 
	PA_PartitionMethod = stringmatch(ctrlName, "UserDefined") ? 0 : PA_PartitionMethod 

End




Function PA_LoadConCatRunInfo()

	wave/t file_index = root:index:file_index
	wave/t rn_series = root:index:rn_series
	Killwaves/z AllRunInfo

	string fileName, fullFileName
	string tempStr
	variable idex, num, currentTotal,  fileID, numThisFile
			
	num = numpnts(file_index)

	make/t/o/n=0 RunInfo_att
	make/t/o/n=0 myTempText

	make/o/n=(numpnts(rn_series),9) AppendedRunRunInfo=nan
	
	currentTotal=0
	STRUCT HDF5DataInfo di	// Defined in HDF5 Browser.ipf.
	InitHDF5DataInfo(di)	// Initialize structure.

	for (idex=0;idex<num;idex+=1)
		fullFileName=file_index[idex]
		fileName = ParseFilePath(0, fullFileName, ":", 1, 0)		
		if (strsearch(fileName, "intermediate", 0)>=0)		//1.15HE
			continue
		endif
		HDF5OpenFile/r fileID as fullFileName
		if (V_Flag)  //1.22A
			DoAlert 1,  "Had problems opening the file "+	fullFileName  +" Do not continue if this is a DAQ file.  Continue?"
			if (V_flag==2)
				continue
			endif
		endif
		
		HDF5DatasetInfo(fileID, "/RunInfo", 0, di)
		if (di.ndims==0)  //1.22A
			continue
		endif

		// first deal with run info
		HDF5LoadData/q/o fileID, "RunInfo"
		wave RunInfo
		HDF5CloseFile fileID

		numThisFile=dimsize(RunInfo,0)
		redimension/n=(currentTotal+numThisFile,9) AppendedRunRunInfo
		AppendedRunRunInfo[currentTotal,][]=RunInfo[p-currentTotal][q]
		currentTotal+=numThisFile
	endfor	

	killwaves/z RunInfo
	
	rename AppendedRunRunInfo AllRunInfo

End

//
// General outline
// 
//Press Get index  and choose the folder of the original DAQ files that you want to regroup
// Open the fast mode panel and do setps 1 and 2
//Open the partition average panel. PA_GetPAWin()	 Use the all todo wave.
//Run the PA_FastModeFillInStartStopRun().  This does two things.  Fills in the table in partition average and prepares for partitioning. (step 2)
//Press the button in Partition panel step 3
// Comment out PA_MakeRunInfo in the ipf PK_partitionAvg and replace with with Pedro_PA_MakeRunInfo in function PA_butt_MakePartitonAvg
//In step 4 do not choose to do MS sticks, (we will recalc sticks in the post-partition experiment).  Now we only care about raw (unsticked) spectra
//In step 4 select PToF data
//In step 4 select the number of new runs per new hdf file.  This can be as big as you like.... maybe 200 - 500? ish?
//Press the step 4 button
//
//
//In the experiment with new hdfs.  In the fast mode table, do NOT press the gold button and go.  Show details.
//
//Press button in Step 1.
//Press button in step 2.
//Do NOT press button in step 3.
//In step 4 check the 1st and 4th checkboxes: 'Use these settings...' and 'Interpolate..." 
//Preprocess all todo wave.
//

//  When users want one run for all fast open, one run for all fast closed, and single runs for non fast cycles
// Eliminates first fast open and first fast closed.
// Not tested on data sets without PToF data
Function PA_FastModeFillInStartStopRun()
	
	wave/i StartRun = root:Partition_Avg:StartRun
	wave/i StopRun = root:Partition_Avg:StopRun

	wave/z fastMSRunWithinCycle = root:diagnostics:fastMSRunWithinCycle	
	wave/i/z First1Open = root:First1Open		// todo wave
	wave/i/z First1Closed = root:First1Closed
	wave/i/z allFast = root:allFast
	wave/i/z all = root:all
	wave/i/z allPToF = root:allPToF
	wave/i/z allFastClosed = root:allFastClosed
	wave/i/z allFastOpen = root:allFastOpen
	
	wave/z FastKey = root:diagnostics:FastKey
	wave/z rn_series = root:index:rn_series
	
	nvar PS_DoPToFSticks = root:Partition_Avg:PA_DoPToFSticks
//	svar PA_FastExclusionWaveStr =$"root:Partition_Avg:PA_FastExclusionWaveStr"
	
	if (!WaveExists(rn_series))
		abort "You must first do step 1  of Squirrel."
	endif

	if (!WaveExists(FastKey) || WaveMax(FastKey)!=2 )		//1.19C
		abort "You don't seem to have fast mode data"
	endif

	if (!WaveExists(First1Open))
//		abort "You must first do steps 1 and 2 in the fast mode panel."  //1.19C
		fm_initialise_FMS()
		fm_butt_DefineCycles("")
		fm_butt_makeFirstFastToDos("")
		wave fastMSRunWithinCycle = root:diagnostics:fastMSRunWithinCycle	
		wave/i First1Open = root:First1Open		// todo wave
		wave/i First1Closed = root:First1Closed
		wave/i allFast = root:allFast
		wave/i all = root:all
		wave/i allPToF = root:allPToF
		wave/i allFastClosed = root:allFastClosed
		wave/i allFastOpen = root:allFastOpen
	endif
					
	SetDataFolder root:
	make/i/o/n=(numpnts(fastMSRunWithinCycle)) root:mystartOfFastCycle/wave=mystartOfFastCycle
	mystartOfFastCycle = fastMSRunWithinCycle[p]==0
	sq_create_todo("mystartOfFastCycle and all","tempStartFastTodo")
	wave First1Closed = root:tempStartFastTodo
	sq_create_todo("mystartOfFastCycle or First1Closed","tempStartFastTodo")
	wave First1Closed = root:tempStartFastTodo
	killwaves/z mystartOfFastCycle

	variable numFirst1Closed = numpnts(First1Closed)
	variable numFirst1Open = numpnts(First1Open)

	wave/i FMS_StartRuns = root:index:FMS_StartRuns

	variable numTotalRuns, numNewRuns, idex, currentRun, numPToF, PToFidex, runningTotal
	variable allFastClosedIdex, allFastOpenIdex, tempStart, tempStop, tempRunNumCounter
	string str
	
	numTotalRuns = numpnts(rn_series)
	numPToF = numpnts(allPToF)
	PToFidex=0
	runningTotal=0
	
	redimension/n=(numTotalRuns) StartRun, stopRun 
	allFastClosedIdex=0
	allFastOpenIdex=0
	do
		currentRun=rn_series[idex]
		if (numtype(fastKey[idex])!=0)		// we are in slow mode.. It will be a single run  
			// this run has PToF data//1.16G
			if( WaveExists(allPToF) && PToFidex<numPToF && currentRun==allPToF[PToFidex] )	
				if (!PS_DoPToFSticks)
					idex+=1
					PToFidex+=1
					continue
				else
					StartRun[runningTotal] = currentRun
					StopRun[runningTotal]  =currentRun
					runningTotal+=1
					idex+=1
					PToFidex+=1
				endif
			else		//this run doesn't have PTOF
				StartRun[runningTotal] = currentRun
				StopRun[runningTotal]  =currentRun
				runningTotal+=1
				idex+=1
			endif

		else  	// we are in fast mode
			// at start of fast closed segment
			if(currentRun==First1Closed[allFastClosedIdex] || currentRun-1==First1Closed[allFastClosedIdex])	// we are at the start or end of a fast cycle
				tempRunNumCounter = 0 //  fastMSRunWithinCycle[idex]
				do
					idex += 1
					tempRunNumCounter+=1
				// while in fast closed and not at the end and the fast mode counter is increasing
				while(idex<numTotalRuns && FastKey[idex]==2 && allFastClosedIdex+1< numFirst1Closed && rn_series[idex]!=First1Closed[allFastClosedIdex+1])		//1.19A
				if (allFastClosedIdex+1==numFirst1Closed)		//1.20h
					do
						idex += 1
						tempRunNumCounter+=1
					// while in fast closed and not at the end and the fast mode counter is increasing
					while(idex<numTotalRuns && FastKey[idex]==2)		//1.19A
				endif
				
				if (tempRunNumCounter != 1)
					StartRun[runningTotal] = currentRun // +1
					StopRun[runningTotal]  = rn_series[idex-1]  // all[idex-1]
					runningTotal+=1
					allFastClosedIdex+=1
				elseif (idex>=numTotalRuns)
					break
				else // the very next run after the first fast closed is NOT a fast closed
					allFastClosedIdex+=1
					sprintf str, "%d", currentRun
					print "Run "+ str+" seems to be an isolated run (there is only one fast closed run in this part of the fast cycle).  Ignoring this run."
				endif
			elseif(currentRun>First1Closed[allFastClosedIdex] && FastKey[idex]==2 )  // 1.16L
				if (allFastClosedIdex >= numFirst1Closed)
					break
				else
					allFastClosedIdex+=1
				endif

			// we are at the beginning of a fast open segment
			elseif( currentRun==First1Open[allFastOpenIdex])	// we are in the middle of a fast cycle 
				tempRunNumCounter = 0 //  fastMSRunWithinCycle[idex]
				do
					idex += 1
					tempRunNumCounter+=1
				while(idex<numTotalRuns && FastKey[idex]==0)
				if (tempRunNumCounter != 1)
					StartRun[runningTotal] = currentRun // +1
					StopRun[runningTotal]  = rn_series[idex-1]  // all[idex-1]
					runningTotal+=1
					allFastOpenIdex+=1
				elseif (idex>=numTotalRuns)
					break
				else // the very next run after the first fast open is NOT a fast open
					allFastOpenIdex+=1
					sprintf str, "%d", currentRun
					print "Run "+ str+" seems to be an isolated beast (there is only one Fast Open in this part of the cycle.  Am ignoring it."
					endif
			elseif(currentRun>First1Open[allFastOpenIdex] && FastKey[idex]==0) 
				if (allFastOpenIdex >= numFirst1Open)
					break
				else
					allFastOpenIdex+=1
				endif
			else
				print "// Unexpected behavior at ",currentRun, "closed index:",allFastClosedIdex, "open index:",allFastOpenIdex 			
				idex+=1
			endif
		endif	// we are in fast mode			
//		if (mod(runningTotal, 100)==45)
//			print "Working on partitions...", runningTotal, time()
//		endif
	
	while(idex<numTotalRuns && allFastClosedIdex<numFirst1Closed  && allFastOpenIdex<numFirst1Open) // 1.19C
	// this  guarantees that the partitioned fast closed ends with a fast closed

	Deletepoints runningTotal, numTotalRuns, StartRun, stopRun 

	killwaves/z root:tempStartFastTodo			//1.19C
End	


//1.16M
Function PA_FindNumExclusionPts(ExWave)
wave ExWave

	wave rn_series = root:index:rn_series
	wave StartRun = root:Partition_Avg:StartRun
	wave StopRun = root:Partition_Avg:StopRun
	wave numPntsExclusion = root:Partition_Avg:numPntsExclusion
	wave NumRunsInPartition = root:Partition_Avg:NumRunsInPartition
	wave NumRunsInPartitionLessExclusion = root:Partition_Avg:NumRunsInPartitionLessExclusion
	
	variable idex, num, ptA, ptB

	num = numpnts(StartRun)
		
	for (idex=0;idex<num;idex+=1)
		ptA = sq_findRun(rn_series,StartRun[idex])
		ptB = sq_findRun(rn_series,StopRun[idex])
		numPntsExclusion[idex]=sum(ExWave, PtA, PtB)
	endfor

	redimension/n=(numpnts(NumRunsInPartition)) NumRunsInPartitionLessExclusion
	
	NumRunsInPartitionLessExclusion = NumRunsInPartition - numPntsExclusion

End


Function PA_FindCycleNum()

	wave/i allSlow = root:allSlow
	wave rn_series = root:index:rn_series
	wave StartRun = root:Partition_Avg:StartRun
	wave StopRun = root:Partition_Avg:StopRun
	wave FastCycleNum = root:Partition_Avg:FastCycleNum
	wave/i FMS_StartRuns = root:index:FMS_StartRuns
	wave/i FMS_EndRuns = root:index:FMS_EndRuns
	
	variable idex, num, ptA, ptB, run, cycleN, numCycles

	numCycles = dimsize(FMS_StartRuns,0)
	MatrixOp/o 	FMSStart = col(FMS_StartRuns,0)
	redimension/n=(numCycles) FMSStart
	redimension/i FMSStart
	
	num = numpnts(StartRun)
	
	FastCycleNum=nan
	
	for (idex=0;idex<num;idex+=1)
		run = StartRun[idex]
		FindValue/i=(run) allSlow
		if (V_Value>=0)			// slow mode
			continue		
		endif
		cycleN =binarysearchinterp(FMSStart, run)
		if (numtype(cycleN)==0)
			cycleN = floor(cycleN)
		elseif (run>FMSStart[numCycles-1] &&run<FMS_EndRuns[numCycles-1][0]  )	 		// we are at the end
			cycleN = numCycles-1
		endif
		FastCycleNum[idex]=cycleN
	endfor

End


//  Removes potential newly partitioned runs that have zero runs in them due to runs being blacklisted or for exclusion waves or some other reason
Function PA_DeleteEmptyCycles()

	wave StartRun = root:Partition_Avg:StartRun
	wave StopRun = root:Partition_Avg:StopRun
	wave numPntsExclusion = root:Partition_Avg:numPntsExclusion
	wave NumRunsInPartition = root:Partition_Avg:NumRunsInPartition
	wave StartRunTime = root:Partition_Avg:StartRunTime
	wave StopRunTime = root:Partition_Avg:StopRunTime
	wave/z numDAQSecsInPartition = root:Partition_Avg:numDAQSecsInPartition			//1.22A
	wave/z deltaTime = root:Partition_Avg:deltaTime
	wave FastCycleNum = root:Partition_Avg:FastCycleNum
	wave NumRunsInPartitionLessExclusion = root:Partition_Avg:NumRunsInPartitionLessExclusion
	wave FastKeyPart = root:Partition_Avg:FastKeyPart

	wave numMSRaw = root:Partition_Avg:numMSRaw  //1.20S
	wave numPToFDim1 = root:Partition_Avg:numPToFDim1  //1.20S
	wave numPToFDim2 = root:Partition_Avg:numPToFDim2  //1.20S

	nvar PA_PartitionMethod = $"root:Partition_Avg:PA_PartitionMethod"
	svar PA_FastExclusionWaveStr = $"root:Partition_Avg:PA_FastExclusionWaveStr"

	variable idex, num, ptA, ptB, run, cycleN, numCycles
	string firstStr, lastStr, ExtraStr
		
	if (!WaveExists(numDAQSecsInPartition)) 
		make/o/n=(numpnts(StartRun)) root:Partition_Avg:numDAQSecsInPartition/wave=numDAQSecsInPartition
	endif
	if (!WaveExists(deltaTime)) 
		make/o/n=(numpnts(StartRun)) root:Partition_Avg:deltaTime/wave=deltaTime
	endif

 	ControlInfo/W=Partition_avg_panel popup_partitionTodo
 	string todoStr = S_Value

	if (PA_PartitionMethod == 3)		// fast cycle partitioning
		if (strlen(PA_FastExclusionWaveStr)>0)
			wave ExclusionWave = $PA_FastExclusionWaveStr
			sq_create_todo(todoStr + " and not "+NameOfWave(ExclusionWave),"todoStrMore")	
			wave todoStrMore = root:todoStrMore
			if (numpnts(todoStrMore) == 0)
				abort "Please either reselect the todo wave or examine your exclusion wave"
			endif
			todoStr = "todoStrMore"
		endif
	endif
	
	num = numpnts(FastCycleNum)
	for(idex = num-1;idex>=0;idex-=1)
		sprintf firstStr, "%d",  StartRun[idex]
		sprintf lastStr, "%d",   StopRun[idex]
		sq_create_todo(firstStr+"-"+lastStr+" and "+todoStr,"MyTempToDoWave")		// this removes any blacklisted runs
		wave MyTempToDoWave = root:MyTempToDoWave
		if (numpnts(MyTempToDoWave)==0)
			deletepoints idex, 1, StartRun, StopRun,  NumRunsInPartition, StartRunTime, StopRunTime, numDAQSecsInPartition, numPntsExclusion, NumRunsInPartitionLessExclusion,FastCycleNum,FastKeyPart, deltaTime
		else
		endif
	endfor
	
	// I don't think this next for loop is necessary
	num = numpnts(FastCycleNum)
	for(idex = num-1;idex>=0;idex-=1)
		if (numPntsExclusion[idex] ==  NumRunsInPartition[idex] )
			deletepoints idex, 1, StartRun, StopRun,  NumRunsInPartition, StartRunTime, StopRunTime, numDAQSecsInPartition, numPntsExclusion, NumRunsInPartitionLessExclusion,FastCycleNum,FastKeyPart, deltaTime
		endif
	endfor

	num = numpnts(FastCycleNum)
	make/o/n=(num) KeepME = 0
	for(idex = 0;idex<num-1;idex+=1)
		if (numtype(FastCycleNum[idex])==0)		// we have a number		
			if ( numtype(FastCycleNum[idex+1])==0 && FastCycleNum[idex] ==  FastCycleNum[idex+1] )		
				KeepME[idex,idex+1]=1
			endif
		else
			KeepME[idex]=1
		endif
	endfor
	KeepME[num-1]=1		//1.20H
	
	for(idex = 0;idex<num-1;idex+=1)  //1.20S  users may have indexed a run through the _p file but not the _m file.
		if (numtype(numMSRaw[idex])!= 0 && numtype(numPToFDim1[idex])!= 0)
			KeepME[idex]=0
		endif
	endfor
	
	for(idex = num-1;idex>0;idex-=1)
		if (KeepME[idex]==0)
			deletepoints idex, 1, StartRun, StopRun, numPntsExclusion, NumRunsInPartition, StartRunTime, StopRunTime, numDAQSecsInPartition, NumRunsInPartitionLessExclusion, FastCycleNum,FastKeyPart, deltaTime
		endif
	endfor

	killwaves/z todoMore, KeepME, tempTodo, root:MyTempToDoWave, todoStrMore

End


//  Sets numSecsInPartition
Function PA_FindTimeWithinPartition()

	wave StartRun = root:Partition_Avg:StartRun
	wave StopRun = root:Partition_Avg:StopRun
	wave numPntsExclusion = root:Partition_Avg:numPntsExclusion
	wave NumRunsInPartitionLessExclusion = root:Partition_Avg:NumRunsInPartitionLessExclusion
	wave NumRunsInPartition = root:Partition_Avg:NumRunsInPartition
	wave StartRunTime = root:Partition_Avg:StartRunTime
	wave StopRunTime = root:Partition_Avg:StopRunTime
	wave/z numDAQSecsInPartition = root:Partition_Avg:numDAQSecsInPartition
	wave/z deltaTime = root:Partition_Avg:deltaTime

	wave TimeAcquiringMSOpenInRun = root:diagnostics:TimeAcquiringMSOpenInRun
	wave TimeAcquiringMSClosedInRun =  root:diagnostics:TimeAcquiringMSClosedInRun
	wave TimeAcquiringPToFInRun =  root:diagnostics:TimeAcquiringPToFInRun

	wave FastKey =  root:diagnostics:FastKey

	svar PA_FastExclusionWaveStr=root:Partition_Avg:PA_FastExclusionWaveStr		// 1.16M
	wave ExclusionWave = $PA_FastExclusionWaveStr
	
	wave rn_series = root:index:rn_series
	wave t_series = root:index:t_series			//1.19C

	if (!WaveExists(numDAQSecsInPartition)) 
		make/o/n=(numpnts(StartRun)) root:Partition_Avg:numDAQSecsInPartition/wave=numDAQSecsInPartition
	endif
	if (!WaveExists(deltaTime)) 
		make/o/n=(numpnts(StartRun)) root:Partition_Avg:deltaTime/wave=deltaTime
	endif

	make/free/o/n=(numpnts(t_series)) timeDaq
	timeDaq =(TimeAcquiringMSOpenInRun + TimeAcquiringMSClosedInRun +TimeAcquiringPToFInRun)*(!ExclusionWave[p])
	variable idex, num, ptA, ptB, run, cycleN, numCycles

	num = numpnts(StartRun)
	
	make/i/o/n=(num) root:Partition_Avg:FastKeyPart/wave = FastKeyPart

	for(idex = 0;idex<num;idex+=1)
		ptA = sq_findRun(rn_series,StartRun[idex])
		ptB = sq_findRun(rn_series,StopRun[idex])
		numDAQSecsInPartition[idex] = sum(timeDaq, ptA, ptB)	
		FastKeyPart[idex] = FastKey[ptA]		// indicates if in fast open or fast closed
		numPntsExclusion[idex]=sum(ExclusionWave, PtA, PtB)
	endfor
	
	redimension/n=(numpnts(NumRunsInPartition)) NumRunsInPartitionLessExclusion
	
	NumRunsInPartitionLessExclusion = NumRunsInPartition - numPntsExclusion

End


//1.19C
Function PA_NewHDFFileKey()

	wave rn_series = root:index:rn_series
	wave detector_num = root:diagnostics:detector_num			// triggers a new run	
	wave mFinish = root:diagnostics:mFinish	// triggers a new DAQ file
	wave numPtsRawSpectra = root:diagnostics:numPtsRawSpectra	// triggers a new DAQ file
	wave ptofNumSpectraPerChop = root:diagnostics:ptofNumSpectraPerChop	// triggers a new DAQ file
	wave ePToF_enabled = root:diagnostics:ePToF_enabled	// triggers a new DAQ file

	wave/i StartRun = root:Partition_Avg:StartRun
	wave/i StopRun = root:Partition_Avg:StopRun
	wave StartRunTime = root:Partition_Avg:StartRunTime
	wave StopRunTime = root:Partition_Avg:StopRunTime
	wave NumRunsInPartition = root:Partition_Avg:NumRunsInPartition
	wave FastKeyPart = root:Partition_Avg:FastKeyPart
	wave FastCycleNum = root:Partition_Avg:FastCycleNum
	wave/z DeltaTime = root:Partition_Avg:DeltaTime
	wave/z NumDAQSecsInPartition = root:Partition_Avg:NumDAQSecsInPartition

	nvar PA_NumParitionsPerHdf = root:Partition_Avg:PA_NumParitionsPerHdf
	nvar PS_DoPToFSticks = root:Partition_Avg:PA_DoPToFSticks
	svar PA_FastExclusionWaveStr = root:Partition_Avg:PA_FastExclusionWaveStr
	Wave/z ExclusionWave = $PA_FastExclusionWaveStr 

	wave squirrel_index = root:index:squirrel_index
	wave series_Index = root:index:series_Index

	if (!WaveExists(numDAQSecsInPartition)) 
		make/o/n=(numpnts(StartRun)) root:Partition_Avg:numDAQSecsInPartition/wave=numDAQSecsInPartition
	endif
	if (!WaveExists(deltaTime)) 
		make/o/n=(numpnts(StartRun)) root:Partition_Avg:deltaTime/wave=deltaTime
	endif

	ControlInfo/W=Partition_Avg_Panel popup_partitionTodo
	string todoStr = S_Value

	variable idex, jdex, num, numRuns, ExclusionFlag, numMSwaves,numPToFwaves,wmin, wmax,lastFastCycleNum
	variable MSSOpenExists, MSSDiffExists, MSSClosedExists, PToFExists
	variable MSClosedpos,MSOpenpos,  ptof_stickpos, MSSOpenpos, MSSClosedpos, MSSDiffpos
	variable MSFlag, PToFFlag, countMS, countPToF
	string startStr,stopStr,MSFlagWaveList, PToFFlagWaveList
	
	duplicate/o/free rn_series rn_seriesInt
	Redimension/i/u rn_seriesInt
	
	num = numpnts(StartRun)
	numRuns = numpnts(rn_series)

	sq_makeTodoallMS()
	wave/i allMS = root:allMS
	sq_makeToDoAllPToF()
	wave/i allPToF = root:allPToF
 	make/o/n=(numRuns) maskWaveAllMS, maskWaveAllPToF
 	sq_makeMaskFromTodofindRun(maskWaveAllMS,allMS)
 	sq_makeMaskFromTodofindRun(maskWaveAllPToF,allPToF)

	MSFlagWaveList = "root:diagnostics:detector_num/root:diagnostics:numPtsRawSpectra/root:diagnostics:mStart/root:diagnostics:mFinish/"
 	PToFFlagWaveList="root:diagnostics:ptofNumSpectraPerChop/root:diagnostics:ePToF_enabled/root:diagnostics:numPtsRawSpectra/root:diagnostics:mStart/root:diagnostics:mFinish/"
	numMSwaves = ItemsInList(MSFlagWaveList, "/")
	make/free/o/n=(numMSwaves) MSFlagValWave
	numPToFwaves = ItemsInList(PToFFlagWaveList, "/")
	make/free/o/n=(numPToFwaves) PToFFlagValWave
 		 
	ExclusionFlag = strlen(PA_FastExclusionWaveStr)> 0 && WaveExists(ExclusionWave)
		
	make/o/n=(numRuns) thisTodoMaskWave, FlagWave, tempwave, tempWaveMS, tempWavePToF
	
 	make/i/o/n=(num) root:Partition_Avg:NewHDFKey/wave =NewHDFKey
 	make/o/n=(num) root:Partition_Avg:numMSRaw/wave =numMSRaw
 	make/o/n=(num) root:Partition_Avg:numMSStick/wave =numMSStick
 	make/o/n=(num) root:Partition_Avg:numPToFDim1/wave =numPToFDim1
 	make/o/n=(num) root:Partition_Avg:numPToFDim2/wave =numPToFDim2
 	make/o/n=(num) root:Partition_Avg:MSCount/wave =MSCount
 	make/o/n=(num) root:Partition_Avg:PToFCount/wave =PToFCount
 	numMSRaw=nan
 	numMSStick=nan
 	numPToFDim1=nan
 	numPToFDim2=nan
 	NewHDFKey = 0
 	NewHDFKey[0]=1	
 		
	MSOpenpos=FindDimlabel(squirrel_index,2,"MSOpen")	
	MSClosedpos=FindDimlabel(squirrel_index,2,"MSClosed")	
	MSSOpenpos = FindDimlabel(squirrel_index,2,"MSSOpen")
	MSSDiffpos = FindDimlabel(squirrel_index,2,"MSSDiff")
	MSSClosedpos = FindDimlabel(squirrel_index,2,"MSSClosed")
	ptof_stickpos=FindDimlabel(squirrel_index,2,"ptof_stick")	

	make/free/o/n=(numRuns) MSClosedSpectraSize //= squirrel_index[series_Index[p]][4][MSClosedpos]	
	make/free/o/n=(numRuns) MSSDiffSpectraSize //= squirrel_index[series_Index[p]][4][MSSDiffpos]	
	make/free/o/n=(numRuns) ptofStickSpectraSize //= squirrel_index[series_Index[p]][4][ptof_stickpos]	
	make/free/o/n=(numRuns) ptofStick2SpectraSize //= squirrel_index[series_Index[p]][5][ptof_stickpos]	

 	for(idex=0;idex<numRuns;idex+=1)		//1.20S
 		MSClosedSpectraSize[series_index[idex]]=squirrel_index[idex][4][MSClosedpos]	
 		MSSDiffSpectraSize[series_index[idex]]=squirrel_index[idex][4][MSSDiffpos]	
 		ptofStickSpectraSize[series_index[idex]]=squirrel_index[idex][4][ptof_stickpos]	
 		ptofStick2SpectraSize[series_index[idex]]=squirrel_index[idex][5][ptof_stickpos]	
	endfor

	countMS=0; countPToF=0
	MSCount=nan; PToFCount=nan
	
 	for (idex=0;idex<num;idex+=1)
		
//		if (idex==766)
//			print idex
//		endif
		
		sprintf startStr, "%d", StartRun[idex]
		sprintf stopStr, "%d", StopRun[idex]
		lastFastCycleNum=numtype(FastCycleNum[idex])== 0 ? FastCycleNum[idex] : lastFastCycleNum
//		if (ExclusionFlag)
//			sq_create_todo(startStr+"-"+stopStr+" and "+todoStr+" and not "+PA_FastExclusionWaveStr,"MyTempToDoWave")		// this removes any blacklisted runs
//		else
//			sq_create_todo(startStr+"-"+stopStr+" and "+todoStr,"MyTempToDoWave")		// this removes any blacklisted runs
//		endif
		variable startPos1
		if (ExclusionFlag)		//1.20H
			wave MyTempToDoWave = sq_create_todo_simple(StartRun[idex], StopRun[idex], rn_seriesInt, ExclusionWave, "MyTempToDoWave", startPos1)
		else
			sq_create_todo(startStr+"-"+stopStr,"MyTempToDoWave")
			wave MyTempToDoWave = root:MyTempToDoWave
		endif
//		wave MyTempToDoWave = root:MyTempToDoWave

 		if (numpnts(MyTempToDoWave)==0)
 			print "// There seems to be something wrong with row "+num2str(idex)+" "+startStr+"-"+stopStr+". This may be due to an exclusion wave; Removing."
 		else
 			sq_makeMaskFromTodofindRun(thisTodoMaskwave,MyTempToDoWave)
			Fastop tempWaveMS = thisTodoMaskwave*maskWaveAllMS
			MSFlag = WaveMax(tempWaveMS)>0
			Fastop tempWavePToF = thisTodoMaskwave*maskWaveAllPToF
 			PToFFlag = WaveMax(tempWavePToF)>0

 			Fastop tempWave = MSClosedSpectraSize*tempWaveMS  ; numMSRaw[idex]=WaveMax(tempWave)
 			Fastop tempWave = MSSDiffSpectraSize*tempWaveMS  ; numMSStick[idex]=WaveMax(tempWave)
		 	Fastop tempWave = ptofStickSpectraSize*tempWavePToF  ; numPToFDim1[idex]=WaveMax(tempWave)
		 	Fastop tempWave = ptofStick2SpectraSize*tempWavePToF  ; numPToFDim2[idex]=WaveMax(tempWave)
	 		
	 		MSCount[idex]= MSFlag ? countMS : nan
	 		PToFCount[idex]= PToFFlag ? countPToF : nan

	 		if (WaveMin(MSFlagValWave)==0 && WaveMax(MSFlagValWave)==0 )		// not initialized.  First run in partition could be PToF only
	 			if (MSFlag)
		 			for (jdex=0;jdex<numMSwaves;jdex+=1)
						wave w = $stringFromList(jdex, MSFlagWaveList, "/")
						FlagWave =thisTodoMaskwave*w
		 				wmin =WaveMin(FlagWave)	 
		 				wmax =WaveMax(FlagWave)	 
		 				if (wmin == wmax)	 				
		 					MSFlagValWave[jdex]=WaveMin(FlagWave)		
	 					else
	 						print "// There is something wrong with the values in "+stringFromList(jdex, MSFlagWaveList, "/")+" for row "+num2str(idex) + " "+startStr+"-"+stopStr
	 					endif
	 				endfor
	 			endif
	 		endif
	 		if (WaveMin(PToFFlagValWave)==0 && WaveMax(PToFFlagValWave)==0 )		// not initialized.  First run in partition could be PToF only
	 			if (PToFFLag && PS_DoPToFSticks)
	 				for (jdex=0;jdex<numPToFwaves;jdex+=1)
						wave w = $stringFromList(jdex, PToFFlagWaveList, "/")
						FlagWave =thisTodoMaskwave*w
		 				wmin =WaveMin(FlagWave)	 
		 				wmax =WaveMax(FlagWave)	 
		 				if (wmin == wmax)	 				
		 					PToFFlagValWave[jdex]=WaveMin(FlagWave)		
	 					else
	 						print "// There is something wrong with the values in "+stringFromList(jdex, PToFFlagWaveList, "/")+" for row "+num2str(idex) + " "+startStr+"-"+stopStr
	 					endif
	 				endfor
	 			endif // PToF
 			else
	 			if (MSFlag)
		  			for (jdex=0;jdex<numMSwaves;jdex+=1)
						wave w = $stringFromList(jdex, MSFlagWaveList, "/")
						FlagWave =thisTodoMaskwave*w
		 				wmin =WaveMin(FlagWave)	 
		 				wmax =WaveMax(FlagWave)	 
		 				if (wmin == wmax)	 				
			 				if (MSFlagValWave[jdex]!= wmin)		
			 					NewHDFKey[idex]=1
			 					MSFlagValWave[jdex]= wmin
//			 					FastCycleNum[idex,]-= (FastCycleNum[idex]== 0 ? 0 :  (lastFastCycleNum+1))
			 				endif
			 			else
	 						print "// There is something wrong with the values in "+stringFromList(jdex, MSFlagWaveList, "/")+" for row "+num2str(idex) + " "+startStr+"-"+stopStr
			 			endif
					endfor
				endif // MS Flag
				if (PToFFLag && PS_DoPToFSticks)
	 				for (jdex=0;jdex<numPToFwaves;jdex+=1)
						wave w = $stringFromList(jdex, PToFFlagWaveList, "/")
						FlagWave =thisTodoMaskwave*w
		 				wmin =WaveMin(FlagWave)	 
		 				wmax =WaveMax(FlagWave)	 
		 				if (wmin == wmax)	 				
		 					if (PToFFlagValWave[jdex]!= wmin)		
		 						NewHDFKey[idex]=1
		 						PToFFlagValWave[jdex]=wmin
//		 						FastCycleNum[idex,]-= (FastCycleNum[idex]== 0 ? 0 :  lastFastCycleNum)
			 					continue
		 					endif
		 				else
 							print "// There is something wrong with the values in "+stringFromList(jdex, PToFFlagWaveList, "/")+" for row "+num2str(idex) + " "+startStr+"-"+stopStr
		 				endif
	 				endfor
	 			endif // PToF

			endif		// idex = 0 or not
			if (NewHDFKey[idex]!=1 && mod(idex, PA_NumParitionsPerHdf)==0)
		 		NewHDFKey[idex]=1
//				FastCycleNum[idex,]-= (FastCycleNum[idex]== 0 ? 0 :  (lastFastCycleNum+1))
			endif
			
			countMS+=MSFlag	
			countPToF+=PToFFlag	
		endif		// this partition has zero runs
	endfor

	for (idex=1;idex<num;idex+=1)
		countMS = numtype(MSCount[idex])==0 ? MSCount[idex] : countMS
		countPToF = numtype(PToFCount[idex])==0 ? PToFCount[idex] : countPToF
		if (NewHDFKey[idex]==1)
			MSCount[idex,] -= countMS
	 		PToFCount[idex,] -= countPToF
	 		countMS=0
	 		countPToF=0
		endif
	endfor

	killwaves/z maskWaveAllMS, maskWaveAllPToF
	killwaves/z maskWave, FlagWave, MyTempToDoWave,thisTodoMaskWave, FlagWave, tempwave, tempWaveMS, tempWavePToF
	
End



// Added in 1.19E for fast mode where they don't want to collapse the entire fast open run.
// collapseFlag =1 means that if we have remaining run we just add them to the previous new run. so numInNew is a minimum
// collapseFlag =0 means that if we have remaining run we make a new run. so numInNew is a maximum
// PRESUMES fast runs are continuous... we rely on the previous use of calling the function for fast mode 
// to distinguish if we are at the beginning of fast cycles.
// NOT AVAILABLE VIA THE PANEL>>>>  CALL FROM COMMAND LINE
// PartitionFastWithXruns(4,0)  would group fast mode runs into 4 or fewer runs.
// PartitionFastWithXruns(3,0)  would group fast mode runs into 3 or more runs.

Function PartitionFastWithXruns(numInNew,collapseFlag)
variable numInNew, collapseFlag

	PA_CheckParitionOption("FixedFast",1)
	PA_FastModeFillInStartStopRun()
//	PA_butt_ResetTimeValues("")

	wave/i StartRun = root:Partition_Avg:StartRun
	wave/i StopRun = root:Partition_Avg:StopRun
//	wave/i NumSecsInPartition = root:Partition_Avg:NumSecsInPartition
	
	variable idex, num, numRunsOrig, numRunsOrigPart, numRunsNewPart, kdex, currentPos, runDelta

	num = numpnts(StopRun)
	numRunsOrig = ceil(StopRun[num - 1] - StartRun[0]+1)
	
	//  make these bigger than they need to be and keep track.... should be faster than incrementing waves one by one
	make/o/i/n=(numRunsOrig) root:Partition_Avg:NewStartRun /wave=NewStartRun
	make/o/i/n=(numRunsOrig) root:Partition_Avg:NewStopRun	/wave=NewStopRun
	
	currentPos=0 
	for (idex=0;idex<num;idex+=1)	// work backwards so can insert points nicely?
		numRunsOrigPart = StopRun[idex] - StartRun[idex]+1
		if (collapseFlag)
			numRunsNewPart = floor(numRunsOrigPart/numInNew)
		else
			numRunsNewPart = ceil(numRunsOrigPart/numInNew)
		endif
		for (kdex=0;kdex<numRunsNewPart;kdex+=1)
			if (kdex ==numRunsNewPart-1 )			// we are at the end
//				if (collapseFlag)
//					NewStartRun[currentPos]=StartRun[idex]+kdex*numInNew
//					NewStopRun[currentPos]=StopRun[idex]+(kdex+1)*numInNew - 1
//					currentPos+=1
//				else
					NewStartRun[currentPos]=StartRun[idex]+kdex*numInNew
					NewStopRun[currentPos]=StopRun[idex]
					currentPos+=1
//				endif
			else
				NewStartRun[currentPos]=StartRun[idex]+kdex*numInNew
				NewStopRun[currentPos]=StartRun[idex]+(kdex+1)*numInNew - 1
				currentPos+=1
			endif
		endfor
	
	endfor		// loop through original fast mode cycles

	DeletePoints currentPos, numRunsOrig, NewStartRun,NewStopRun
	duplicate/o NewStartRun root:Partition_Avg:StartRun
	duplicate/o NewStopRun root:Partition_Avg:StopRun

End


// 1.19F
Function/wave sq_create_todo_simple(start, stop, rn_series, ExclusionWave, Namestr, startPos)
variable start, stop, startPos
wave rn_series,ExclusionWave
string Namestr

	variable idex, good=0, num=stop-start+1, pos1,pos2
	
	FindValue/S=(startPos)/U=(start) rn_series
	pos1 = V_Value
	
	FindValue/S=(startPos)/U=(stop) rn_series
	pos2 = V_Value
	
	num=pos2-pos1+1
	
	make/o/u/n=(num) $Namestr/wave=todo
	
	for(idex=0;idex<num;idex+=1)
		if (!ExclusionWave[pos1+idex])
			todo[good]=rn_series[pos1+idex]
			good+=1
		endif  
	endfor
	
	deletepoints good, num, todo
	
	startPos=pos2
	
	return todo
	 
End


//1.20H
Function PA_MaxNumRunsInPartition(maxNum)
variable maxNum

	wave StartRun=root:Partition_Avg:StartRun
	wave StopRun=root:Partition_Avg:StopRun
	 
	variable var,kdex, idex, num = numpnts(StartRun), startR, stopR,grouping
	
	make/free/i/n=(num) delta = StopRun - StartRun+1
	
	for(idex=num-1;idex>=0;idex-=1)
		if (delta[idex]>	maxNum)
			startR = StartRun[idex]
			stopR = StopRun[idex]
			var = ceil(delta[idex]/maxNum)
			insertpoints idex, (var-1),  StopRun, StartRun
			for (kdex=0;kdex<var;kdex+=1)
				StartRun[idex+kdex] = startR+kdex*(maxNum)
				StopRun[idex+kdex] = min(stopR, StartRun[idex+kdex]+maxNum-1)
			endfor
		endif
	endfor

End

Function PA_butt_SetPartition(ctrlName)  : ButtonControl
	string ctrlName

	nvar PA_PartitionMethod = root:Partition_Avg:PA_PartitionMethod
 
	switch(PA_PartitionMethod)
		case 1 :
			PA_butt_PartByTime()
		break
		case 2 :
			PA_butt_PartByRunNum()
		break
		case 3 :
			PA_FastModeFillInStartStopRun()
		break
		default:
			abort "Please use the radio buttons in step 2 to make your selection for automatic StartRun and StopRun determination."
	endswitch

End


Function PA_verifyRuns(StartRun, StopRun, runStartPt, runStopPt, todo)
wave/i StartRun, StopRun, runStartPt, runStopPt, todo

	variable idex, num=numpnts(StartRun)
	string startStr, stopStr, todoStr = NameofWave(todo)
	
//  first make sure that the runs exist
	if ( WaveMin(runStartPt)<0 || WaveMin(runStopPt)<0)
		Wavestats/q/m=1 runStartPt
		if (V_min<0)
			abort "At row "+Num2istr(V_minLoc)+ " the StartRun isn't a valid run." 
		else
			Wavestats/q/m=1 runStopPt
			abort "At row "+Num2istr(V_minLoc)+ " the StopRun isn't a valid run." 
		endif
	endif

	wave/wave ResultsWave = gen_joinTwoIntegerWaves(StartRun, todo, 1)  // 1 means intersection
	wave Indx = ResultsWave[%Indx]
	wave DuplicatesWave = ResultsWave[%Result]
	if (numpnts(DuplicatesWave) != numpnts(StartRun))
		duplicate/o 	StartRun root:StartRunTodo/wave=StartRunTodo
		Note StartRunTodo "TYPE:todo;"
		killwaves/z Indx, DuplicatesWave
		sq_create_todo("StartRunTodo and not "+NameofWave(todo),"StartRunsNotInTodo")	
		wave StartRunsNotInTodo = root:StartRunsNotInTodo
		edit StartRunsNotInTodo
		abort "The table shows the runs that are in the StoptRun wave but not in the selected todo. Please fix."
	endif
		
	wave/wave ResultsWave = gen_joinTwoIntegerWaves(StopRun, todo, 1)  // 1 means intersection
	wave Indx = ResultsWave[%Indx]
	wave DuplicatesWave = ResultsWave[%Result]
	if (numpnts(DuplicatesWave) != numpnts(StopRun))
		duplicate/o 	StopRun root:StopRunTodo/wave=StopRunTodo
		Note StopRunTodo "TYPE:todo;"
		killwaves/z Indx, DuplicatesWave
		sq_create_todo("StopRunTodo and not "+NameofWave(todo),"StopRunsNotInTodo")	
		wave StopRunsNotInTodo = root:StopRunsNotInTodo
		edit StopRunsNotInTodo
		abort "The table shows the runs that are in the StopRun wave but not in the selected todo. Please fix."
	endif

	killwaves/z Indx, DuplicatesWave
End


Function/wave gen_joinTwoIntegerWaves(wave1, wave2, AndOrFlag)
Wave wave1, wave2
variable AndOrFlag

	Wavestats/q/m=1 wave1
	if (V_numNans>0 || V_numInfs>0)
		abort "The wave "+nameofwave(wave1) +" has nans or infs - aborting!"
	endif

	Wavestats/q/m=1 wave2
	if (V_numNans>0 || V_numInfs>0)
		abort "The wave "+nameofwave(wave2) +" has nans or infs - aborting!"
	endif
	
	variable idex, num1=numpnts(Wave1), num2=numpnts(Wave2)
	
	make/free/o/i/n=(num1) intWave1 = round(wave1[p])
	make/free/o/i/n=(num2) intWave2 = round(wave2[p])

	make/free/o/wave/n=2 resultsWave 
	SetDimLabel 0,0, Indx, resultsWave
	SetDimLabel 0,1, Result, resultsWave

	if (num1==0 && num2==0 )
		abort "Both waves have zero many points.  Aborting from gen_FindTwoIntegerWaves"
	endif
	
	if (num1==0)
		if (!AndOrFlag)  // or, union
			make/i/o/n=(num2) DuplicatesWave, IndxWave
			DuplicatesWave=intWave2
			IndxWave = p
			resultsWave[%Result]=DuplicatesWave
			resultsWave[%Indx]=IndxWave
		else   // and, intersection
			make/i/o/n=(0) DuplicatesWave, IndxWave
			resultsWave[%Result]=DuplicatesWave
			resultsWave[%Indx]=IndxWave
		endif
		return resultsWave
	elseif (num2==0)
		if (!AndOrFlag)  // or, union
			make/i/o/n=(num1) DuplicatesWave, IndxWave
			DuplicatesWave=intWave2
			IndxWave = p
			resultsWave[%Result]=DuplicatesWave
			resultsWave[%Indx]=IndxWave
		else   // and, intersection
			make/i/o/n=(0) DuplicatesWave, IndxWave
			resultsWave[%Result]=DuplicatesWave
			resultsWave[%Indx]=IndxWave
		endif
		return resultsWave
	else
		duplicate/o intWave1 UnionWave
		insertpoints num1, num2, UnionWave
		UnionWave[num1,]=intWave2[p-num1]	
		#if (IgorVersion()>=7)
			if (AndOrFlag==0)  // or, or union
				Findduplicates/Indx=IndxWave/z/RN=NoDuplicatesWave UnionWave
				resultsWave[%Result]=NoDuplicatesWave
			else  // intersection
				Findduplicates/Indx=IndxWave/z/DN=DuplicatesWave UnionWave
				resultsWave[%Result]=DuplicatesWave
			endif
		#else
			duplicate/o UnionWave, IndxWave
			MakeIndex UnionWave, IndxWave
			IndexSort IndxWave, UnionWave
			duplicate/free UnionWave UnionWaveDiff
			UnionWaveDiff[0, numpnts(UnionWaveDiff)-2] = UnionWave[p+1] - UnionWave[p] 
			if (AndOrFlag==1)  // or, or union
				for( idex= num1+num2-1;idex>=0;idex-=1)
					if (UnionWaveDiff[idex]==0)  // or, or union
						DeletePoints idex, 1, UnionWave, IndxWave					
					endif
				endfor
				resultsWave[%Result]=UnionWave
			else  // intersection
				for( idex= num1+num2-1;idex>=0;idex-=1)
					if (UnionWaveDiff[idex]!=0)  // or, or union
						DeletePoints idex, 1, UnionWave, IndxWave					
					endif
				endfor
				resultsWave[%Result]=UnionWave
			endif
		#endif	
		resultsWave[%Indx]=IndxWave		
		return resultsWave
	endif
End

